Package: DrugVsDisease
Type: Package
Title: Comparison of disease and drug profiles using Gene set
        Enrichment Analysis
Version: 2.55.0
Date: 2018-11-10
Author: C. Pacini
Maintainer: j. Saez-Rodriguez <saezrodriguez@ebi.ac.uk>
Description: This package generates ranked lists of differential gene
        expression for either disease or drug profiles. Input data can
        be downloaded from Array Express or GEO, or from local CEL
        files. Ranked lists of differential expression and associated
        p-values are calculated using Limma. Enrichment scores
        (Subramanian et al. PNAS 2005) are calculated to a reference
        set of default drug or disease profiles, or a set of custom
        data supplied by the user. Network visualisation of significant
        scores are output in Cytoscape format.
LazyData: yes
LazyLoad: yes
License: GPL-3
Depends: R (>= 2.10), affy, limma, biomaRt, ArrayExpress, GEOquery,
        DrugVsDiseasedata, cMap2data, qvalue
Imports: annotate, hgu133a.db, hgu133a2.db, hgu133plus2.db, RUnit,
        BiocGenerics, xtable
biocViews: Microarray, GeneExpression, Clustering
NeedsCompilation: no
Packaged: 2026-04-28 22:25:40 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/DrugVsDisease
git_branch: devel
git_last_commit: 04ae452
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28

test_.getESscores<-function(){
	library(RUnit)
	library(DrugVsDiseasedata)
	data(diseaseRL,package="DrugVsDiseasedata")
	d<-diseaseRL[,1]
	d<-as.matrix(d)
	d1<-DrugVsDisease:::.ranknamemat(d,2,TRUE)
	d2<-DrugVsDisease:::.ranknamemat(d,2,FALSE)
	checkTrue(!is.null(colnames(DrugVsDisease:::.getESscores(d1,d2,drugPRLs=diseaseRL[,1:20]))))
	
}

test_.KS.drug.disease<-function(){
	library(RUnit)
	library(DrugVsDiseasedata)
	data(diseaseRL,package="DrugVsDiseasedata")
	d<-diseaseRL[,1:3]
	checkTrue(sum(diag(DrugVsDisease:::.KS.drug.disease(d,d)))==3)
	checkTrue(all(DrugVsDisease:::.KS.drug.disease(d,d)<=1))
	checkTrue(all(DrugVsDisease:::.KS.drug.disease(d,d)>=-1.03))
	
}

selectrankedlists <-
function(ranklist,colsinc){
	#get the selected ranklists/pvalues as chosen in colsinc
	seldata<-vector("list",length=2)
	cnames<-colnames(ranklist[[1]])

		seldata[[1]]<-as.matrix(ranklist$ranklist[,colsinc])
		seldata[[2]]<-as.matrix(ranklist$pvalues[,colsinc])
		colnames(seldata[[1]])<-cnames[colsinc]
    colnames(seldata[[2]])<-cnames[colsinc]
	
	names(seldata)<-names(ranklist)
	return(seldata)
	
}

generateprofiles <-
function(input=c("AE","GEO","localAE","local"),normalisation=c("rma","mas5"),accession=NULL, customfile=NULL,celfilepath=NULL,sdrfpath=NULL,case=c("disease","drug"),statistic=c("coef", "t","diff"),annotation=NULL,factorvalue=NULL,annotationmap=NULL,type=c("average","medpolish","maxvar","max"),outputgenedata=FALSE){
	#NB coef as default statistic should be more appropriate as it is more consistent with the generation of the cmap rank profiles which take averages (case, control) and then do ratios.
  #load required packages:
	require(affy)
	require(limma)
	require(biomaRt)
	require(ArrayExpress)
	require(GEOquery)
	require(DrugVsDiseasedata)
	require(qvalue)
	input<-match.arg(input,several.ok=TRUE)
  normalisation<-match.arg(normalisation)
	experimentname=NULL
	statistic<-match.arg(statistic)
	case<-match.arg(case)
	type<-match.arg(type)
	data(genelist,package="DrugVsDiseasedata")
	data(annotationlist,package="DrugVsDiseasedata")
	
	if(!is.null(annotationmap)){
		if(!is.matrix(annotationmap)){
			annotationmap<-read.table(annotationmap)
			annotationmap<-as.matrix(annotationmap)
		}
	}
	
	if(input=="GEO"){
		if(is.null(accession)){stop('An accession reference is required to download from GEO database')}
		#download GDS file using GEOquery package
		GEOdownload<-.datafromGEO(accession,factorvalue=factorvalue,case=case)
		#extract the microarray platform
		platform<-GEOdownload$platform
		#check if the platform annotation has been passed as a parameter
		if(!is.null(annotation)){
			platform<-annotation
		}
		if(is.null(platform)){stop('Type of platform unavailable in the experiment information. Please provide using the annotation option')}
		#extact the probenames
		probenames<-rownames(GEOdownload$normalised)
		#find the annotation from BioMart of the probes to Ensembl genes
		if(is.null(annotationmap)){
		   annotation<-.convertEnsembl(platform,values=probenames)}else{annotation=annotationmap}
		#combine the expression values from probes to genes
		datagenes<-.combineEnsembl(GEOdownload$normalised,annotation,genelist,type=type)
		#fit the linear models
		if(outputgenedata){d2<-datagenes}else{
		d2<-.fitlms(normalised=datagenes,customfactors=GEOdownload$customfactors,case=case,statistic=statistic,experiment=experimentname)}
	    
	}
	if(input=="localAE"){
		if(is.null(celfilepath)|is.null(sdrfpath)){stop('The file path for CEL files and the sdrf file path are required to import Array Express files from a local directory')}
		#read Array Express downloaded CEL and sdrf files, using ArrayExpress package
		AEdownload<-.readlocalAE(celpath=celfilepath,sdrfpath=sdrfpath)
		#normalise data
		normaliseddata<-.normalisedata(AEdownload$affyobject,normalisation=normalisation)
		#extract platform type
		platform<-annotation(normaliseddata)
		#get the expression data
		exprdata<-exprs(normaliseddata)
		if(normalisation=="mas5")exprdata<-log(exprdata,2)
		   if(is.null(annotationmap)){annotation<-.convertEnsembl(platform,rownames(exprdata))}else{annotation<-annotationmap}
		datagenes<-.combineEnsembl(exprdata,annotation,genelist,type=type)
		if(outputgenedata){d2<-datagenes}else{
		d2<-.fitlms(normalised=datagenes,experimentAEpdata=AEdownload$factors,experiment=experimentname,case=case,statistic=statistic)}
	}
	if(input=="AE"){
		if(is.null(accession)){stop('An accession reference is required to download from Array Express database')}
		AEdownload<-.datafromAE(experiment=accession)
		platform<-AEdownload$platform

		normaliseddata<-.normalisedata(AEdownload$affyobject,normalisation=normalisation)
		exprdata<-exprs(normaliseddata)
		
		if(normalisation=="mas5")exprdata<-log(exprdata,2)
		   if(is.null(annotationmap)){
			  annotation<-.convertEnsembl(platform,values=rownames(exprdata))}else{annotation<-annotationmap}
		
		datagenes<-.combineEnsembl(exprdata,annotation,genelist,type=type)
		if(outputgenedata){d2<-datagenes}else{
		d2<-.fitlms(normalised=datagenes,experimentAEpdata=AEdownload$factors,experiment=experimentname,case=case,statistic=statistic)}
			
	}
	if(input=="local"){
		if(is.null(celfilepath)|is.null(customfile)){stop('Please specify a path to read the CEL files from using celfilepath and a factor file using customfile')}
		affyobj<-.readlocalCEL(celfilepath)
		normaliseddata<-.normalisedata(affyobj,normalisation=normalisation)
		platform<-annotation(normaliseddata)
		exprdata<-exprs(normaliseddata)
		
		if(normalisation=="mas5")exprdata<-log(exprdata,2)
			  if(is.null(annotationmap)){
			  annotation<-.convertEnsembl(platform,values=rownames(exprdata))}else{annotation<-annotationmap}
		datagenes<-.combineEnsembl(exprdata,annotation,genelist,type=type)
		if(outputgenedata){d2<-datagenes}else{
		d2<-.fitlms(normalised=datagenes,customfactors=customfile,experiment=experimentname,case=case,statistic=statistic)}
	}
	if(!outputgenedata){
	print('Fitted linear models: ')
	print(colnames(d2$ranklist))}

	return(d2)
}

combineProfiles<-function(data){
	if(!is.list(data)){stop('Please provide list of R objects for data')}
	refdata<-data[[1]]
	norm<-list(length=length(data))
	for(i in 2:length(data)){
		#pairwise do the comparison to the ref data
		out<-.mrs(refdata,data[[i]])	
		norm[[i]]<-out$y
	}	
	norm[[1]]<-out$x
	final<-norm[[1]]
	for(i in 1:length(data)){
		temp<-norm[[i]]
		final<-cbind(final,temp[rownames(norm[[1]]),])
	}
	return(final)
}

.datafromGEO <-
function(accession,destdir=".",factorvalue=NULL,case=c("disease","drug")){
	case<-match.arg(case)

	#make sure accession starts with GDS…
	testname<-substr(accession,1,3)
	if(testname!="GDS"){stop('Accession must be of type GDS, check accession name')}
	#if have a GDS accession start reference, try to download file from GEO:
	if(file.exists(paste(destdir,"/",accession,".soft.gz",sep=""))){file.remove(paste(destdir,"/",accession,".soft.gz",sep=""))}
	data<-getGEO(accession,destdir=destdir)
	#convert preprocessed data into expression set.
	eset<-GDS2eSet(data,do.log2=TRUE)
	#extract the names of the factors available in the annotation of the GDS data
	factornames<-names(pData(eset))
	platform<-annotation(eset)
	#check that we have a factor value to use in regression
	if(is.null(factorvalue)){
		sel<-which(factornames%in%c("disease state","dose","disease.state"))
	}else{
		sel<-which(factornames==factorvalue)
	}
	
	if(length(sel)==0&&length(factornames)!=0){
		fn<-c()
		for(i in 1:length(factornames)){
			fn<-paste(fn,factornames[i])
			
		}
		
		stop(paste('Neither disease nor dose/drug variable available for data set. Available factors: ',fn,' use parameter factorvalue to select a factor'))
	}
	
	if(length(sel)==0&&length(factornames)==0){stop('No factornames available in the pData of the eset. Consider processing using the local option.')}
	
	#load the list of factor values used to annotate experiments in the GEO database
	data(GEOfactorvalues,package="DrugVsDiseasedata")
	#extract those factors which are in the list of GEO factors
	factors<-GEOfactorvalues[which(GEOfactorvalues%in%factornames)]
	customfactors<-data.frame(pData(eset)[factors])
	CEL<-rownames(customfactors)
	customfactors<-data.frame(customfactors,CEL)
	factors<-colnames(customfactors)
	#find the factor (default or selected by user with parameter factorvalue) to set as either the "disease" or the "compound" factor - this is the label expected by function fitlm. This factor is used as the main explanatory variable to regress on in the fitlm function. 
	if(case=="disease"){
		if(is.null(factorvalue)){
			sel<-which(factors%in%c("disease state","disease.state"))
			
		}else{
			sel<-which(factors==factorvalue)
	
		}
		colnames(customfactors)[sel]<-"disease"
	}else{
		if(is.null(factorvalue)){
			sel<-which(factors=="dose")
			
		}else{
			sel<-which(factors==factorvalue)
			
		}
		colnames(customfactors)[sel]<-"compound"
	}
	file.remove(paste(destdir,"/",accession,".soft.gz",sep=""))
	return(list(normalised=exprs(eset),customfactors=customfactors,platform=platform))
}
.readlocalCEL <-
function(path){
	#assume reading affymetrix CEL files from a local directory
	affyobject<-ReadAffy(celfile.path=path)
	return(affyobject)
}
.readlocalAE <-
function(celpath,sdrfpath){
	#read CEL files from AE and corresponding sdrf file
	try(CELfiles<-ReadAffy(celfile.path=celpath))
	if(class(CELfiles)[1]=="try-error"){stop(paste('Unable to read CEL files from path: ',celpath,'. Check CEL files and path directory.',sep=""))}
	sdrffile<-read.delim(sdrfpath)
	filenames<-sdrffile[,"Array.Data.File"]
	sortsdrf<-sdrffile[order(sdrffile[,"Array.Data.File"]),]
	#now have sdrf rows matching the order of the CEL files
 	return(list(affyobject=CELfiles,factors=sortsdrf))
}
.datafromAE <-
function(experiment){

	#Get the data from Array Express package and factors from the sdrf file
	try(experimentAEset<-ArrayExpress(experiment))
	if(class(experimentAEset)[1]=="try-error"){stop(paste("Unable to download experiment",experiment,"from Array Express. Please check accession reference and platform for files. Consider using options 'local' or 'localAE' instead."))}
	platform<-annotation(experimentAEset)
	return(list(affyobject=experimentAEset,factors=pData(experimentAEset),platform=platform))		
		
	
}
.normalisedata <-
function(eset,normalisation=c("rma","mas5")){
	normalisation<-match.arg(normalisation)
	if(normalisation=="rma"){
			normalised<-rma(eset)
		
	}else{
		try(normalised<-mas5(eset))
		if(class(normalised)[1]=="try-error"){stop('Error in mas5, check annotation of CEL files are the same')}
		
	}
return(normalised)
}
.calculateES <-
function(data,type=c("fixed","dynamic","range"),adj=c("BH","qvalue"),lengthtest=250,ranges=seq(100,2000,by=100),pvalues=NULL,dynamic.fdr=0.01,signif.fdr=0.01,customRefDB=NULL,case=c("disease","drug"),noperm=5000,stat=c("KS","WSR")){
	case=match.arg(case)
	type=match.arg(type)
	
  	adj=match.arg(adj)
	experimentnames<-colnames(as.matrix(data))
	#data checks here
	if(!is.null(data)&&!is.numeric(data)){stop('Data must be a numeric matrix of expression values or rank numbers')}
	
	#if a customRefDB is not supplied load the default profiles from the cMap2data or DrugVsDiseasedata packages depending on whether the input profile is a drug or disease profile.
	if(is.null(customRefDB)){
		if(case=="disease"){
			data(drugRL,package="cMap2data")
			#drugRL is ranks in decreasing order so rank 1 is highest increase DE
			refDB<-drugRL
			if(stat=="WSR"){
				nogenes<-nrow(refDB)
				splitno<-round(nogenes/2)+1
				refDB<-splitno-refDB
			}
		}else{
			data(diseaseRL,package="DrugVsDiseasedata")
			#diseaseRL is log FC coefficients
			refDB<-diseaseRL
			if(stat=="KS"){refDB<-apply((-1*refDB),2,rank)}
		}
	}else{
		
			refDB=customRefDB
	}
	refDB<-as.matrix(refDB)	
	data<-as.matrix(data)
	#check to make sure the genes in the input profile match those in the reference data set.
	lt<-sum(rownames(data)%in%rownames(refDB))
	if(lt!=nrow(data)) stop('Rownames of input data and reference data do not match')
	#select only those in the input in the ref set too
	refDB<-refDB[rownames(data),]
	if(stat=="KS"){
		#need to have the non rank data first incase want to use the Gant methodology.
		#create two sets of gene names for the input data. One with the highest increase DE expression at the top (rankdata) and one with the largest decrease in DE at the top (rankdatainv)
		datarl<-apply(data,2,function(x) as.integer(rank(x)))
		datarl<-as.matrix(datarl)
		rownames(datarl)<-rownames(data)
		colnames(datarl)<-colnames(data)
	
		rankdata<-.ranknamemat(datarl,2,TRUE)
		rankdatainv<-.ranknamemat(datarl,2,FALSE)
	}else{
		#get the ranks and the sign matrix
		rankdata<-data
		rankdatainv<-data
	}
	
	#type = fixed for a fixed number of genes to use in calculating the KS running sum statistics.
	if(type=="fixed"){
		#calculate enrichment scores, side indicates whether or not to do a one or two tailed test, k is the gene set size.
		outk<-.getESscores(rankdata,rankdatainv,drugPRLs=refDB,uplength=lengthtest,downlength=lengthtest,stat=stat)	
		#get permutation based empirical p-values for enrichment scores	
		signif<-.significantES(ESscores=outk,rankdata=rankdata,rankdatainv=rankdatainv,noperm=noperm,fdr=signif.fdr,uplength=lengthtest,downlength=lengthtest,drugPRLs=refDB,adj=adj,stat=stat)
		names(signif)<-colnames(data)
	}
	#type = range, calculates the KS running sum statistics for a range of gene set sizes.
	if(type=="range"){
		#do dynamic set for find drugs
		outk<-list(length=length(ranges))
		signif<-list(length=length(ranges))
		for(i in 1:length(ranges)){
			#calculate enrichment scores
			outk[[i]]<-.getESscores(rankdata,rankdatainv,drugPRLs=refDB,uplength=ranges[i],downlength=ranges[i],stat=stat)
			#get permutation based empirical p-values for enrichment scores
			signiftemp<-.significantES(ESscores=outk[[i]],rankdata=rankdata,rankdatainv=rankdatainv,noperm=noperm,fdr=signif.fdr,uplength=ranges[i],downlength=ranges[i],drugPRLs=refDB,adj=adj,stat=stat)			
			
			signif[[i]]<-signiftemp	
		}
		
		names(outk)<-paste("range:",ranges,sep="")
		names(signif)<-paste("range:",ranges,sep="")
	}
		
	if(type=="dynamic"){
		#type= dynamic, meaning that the size of the gene set used in the enrichment score calculation from the input profiles, is determined using the adjusted p-values of differential expression
		pvalues<-as.matrix(pvalues)
		#adjust the p-values for multiple hypothesis testing using either Benjamini-Hochberg (BH) or Tibshirani q-value method
    	if(adj=="BH"){
      		pvalues<-apply(pvalues,2,p.adjust)
    	}else{
      		try(pvals<-apply(pvalues,2,function(x) qvalue(x)$qvalues))
      		if(class(pvals)[1]=="try-error"){
      			pvalues<-apply(pvalues,2,p.adjust)
      		}else{
      			pvalues<-pvals	
      		}
    	}
		#signifgenes contains a logical value indicating if have significantly differentially expressed genes after Multiple hypothesis correction for given false discovery rate (dynamic.fdr)
		signifgenes<-apply(pvalues,2,function(x) x<dynamic.fdr)
		#get the ranklists and inverse ranked lists for the reference data set (assuming that the reference set is a rank of decreasing order)
		ranknamedrugPRLs<-.ranknamemat(refDB,2,TRUE)
		ranknamedrugPRLsb<-.ranknamemat(refDB,2,FALSE)
		if(ncol(pvalues)>1){
			#have more than one profile to analyse
			signif<-list(length=ncol(pvalues))
			outk<-list(length=ncol(pvalues))
			positivematrix<-apply(data,2,function(x) x>0)
			upsignif<-positivematrix*signifgenes
			for(i in 1:ncol(pvalues)){
				if(sum(signifgenes[,i])>0){
					#calculate enrichment scores
					
					uplength<-sum(upsignif[,i])
					downlength<-sum(signifgenes[,i])-uplength
					if(uplength<50){
						warning("Number of significantly up-regulated genes is less than 50, top 50 used instead")
						uplength<-50
					}
					if(downlength<50){
						warning("Number of significantly down-regulated genes is less than 50, top 50 used instead")
						downlength<-50
						
					}
					outk[[i]]<-.getESscores(rankdata[,i],rankdatainv[,i],uplength=uplength,downlength=downlength,drugPRLs=refDB,stat=stat)
					#get permutation based empirical p-values for enrichment scores
					signif[[i]]<-.significantES(ESscores=outk[[i]],uplength=uplength,downlength=downlength,rankdata=rankdata,rankdatainv=rankdatainv,noperm=noperm,fdr=signif.fdr,drugPRLs=refDB,adj=adj,stat=stat)}
				else{
					warning(paste("No significantly differentially expressed genes for experiment",colnames(pvalues)[i]))
					outk[[i]]<-NULL
					signif[[i]]<-NULL
				}
			}
			names(outk)<-colnames(data)
			names(signif)<-colnames(data)
		}else{
			#one input profile to analyse
			if(sum(signifgenes)>0){
				positivematrix<-data>0
				upsignif<-positivematrix*signifgenes
				
			   uplength<-sum(upsignif)
			   downlength<-sum(signifgenes)-uplength
			   if(uplength<50){
						warning("Number of significantly up-regulated genes is less than 50, top 50 used instead")
						uplength<-50
					}
				if(downlength<50){
						warning("Number of significantly down-regulated genes is less than 50, top 50 used instead")
						downlength<-50
						
				}
				#calculate enrichment scores
				outk<-.getESscores(rankdata,rankdatainv,drugPRLs=refDB,uplength=uplength,downlength=downlength,stat=stat)	
				#get permutation based empirical p-values for enrichment scores		
				signif<-.significantES(ESscores=outk,rankdata=rankdata,rankdatainv=rankdatainv,noperm=noperm,fdr=signif.fdr,uplength=uplength,downlength=downlength,drugPRLs=refDB,adj=adj,stat=stat)
			}else{
				stop(paste("No significantly differentially expressed genes, consider changing the FDR threshold."))
			}
		names(signif)<-colnames(data)
		names(outk)<-colnames(data)
		}		
	}	
	#so significance (signif) is a list with length=number of input profiles (can be a nested list if type is range so more than one result per profile)

	return(list(scores=outk,significance=signif))	
}
.significantES <-
function(ESscores,rankdata=NULL,rankdatainv=NULL,uplength=250,downlength=250,noperm=1000,fdr=0.01,drugPRLs,adj=adj,stat=c("KS","WSR")){

	#find the significance of the enrichment scores calculated by comparing to random (null hypothesis) permutations of the reference data base

	stat<-match.arg(stat)


	if(is.list(ESscores)){
		#then we have a range of gene set sizes with corresponding enrichment scores	
		resultslist<-list(length=length(ESscores))
		for(i in 1:length(ESscores)){
		#ESscores is a matrix with rows= input profiles and columns = reference profiles
			scorematrix<-ESscores[[i]]
			
				if(is.matrix(scorematrix)){
			
					signifcompounds<-list(length=nrow(scorematrix))
					for(i in 1:nrow(scorematrix)){
      					signifcompounds[[i]]<-.findSignifCompounds(scorematrix[i,],rankdata=rankdata[,i],rankdatainv=rankdatainv[,i],uplength=uplength,downlength=downlength,noperm=noperm,fdr=fdr,adj=adj,stat=stat)
					}
					names(signifcompounds)<-rownames(scorematrix)
				}else{
					signifcompounds<-.findSignifCompounds(scorematrix,rankdata=rankdata,rankdatainv=rankdatainv,uplength=uplength,downlength=downlength,noperm=noperm,fdr=fdr,adj=adj,stat=stat)
				}
			resultslist[[i]]<-signifcompounds
		}
		names(resultslist)<-names(ESscores)
	}else{
		scorematrix<-ESscores
		
		if(is.matrix(scorematrix)){
			#have the diseases in the rows and the drugs in the columns
			#have more than one disease profile:
			signifcompounds<-list(length=nrow(scorematrix))
			for(i in 1:nrow(scorematrix)){
				signifcompounds[[i]]<-.findSignifCompounds(scorematrix[i,],rankdata=rankdata[,i],rankdatainv=rankdatainv[,i],uplength=uplength,downlength=downlength,noperm=noperm,fdr=fdr,adj=adj,stat=stat)
			}		
			names(signifcompounds)<-rownames(scorematrix)
		}else{
			signifcompounds<-list(length=1)
			signifcompounds[[1]]<-.findSignifCompounds(scorematrix,rankdata=rankdata,rankdatainv=rankdatainv,uplength=uplength,downlength=downlength,noperm=noperm,fdr=fdr,adj=adj,stat=stat)
			names(signifcompounds)<-names(ESscores)
		}
	
	resultslist<-signifcompounds
	
}
	#this always outputs a list
	return(resultslist)
	
}
.findSignifCompounds <-
function(scores,rankdata=NULL,rankdatainv=NULL,noperm=100,uplength=250,downlength=250,fdr=fdr,adj=adj,stat=c("KS","WSR")){

	

	if(is.null(rankdata)){stop("Rank data needed for permutation tests")}
		rankdata<-as.matrix(rankdata)
		#generate a random set of gene expression profiles
		size<-nrow(rankdata)
		smatrix<-sapply(1:noperm,function(x) sample.int(size))
		rownames(smatrix)<-rankdata[,1]
		#create the ranklists and decreasing order ranked lists
		samplematrix<-.ranknamemat(smatrix,2,TRUE)
		samplematrixinv<-.ranknamemat(smatrix,2,FALSE)
	

	if(stat=="KS"){
	
		PermScoreup<-.KS.drug.disease(refmatrix=samplematrix,inputmatrix=rankdata,lengthtest=uplength)
		PscoreUpref<-.KS.drug.disease(refmatrix=rankdata,inputmatrix=samplematrix,lengthtest=uplength)
		PscoreUpref<-t(PscoreUpref)
		PermScoredown<-.KS.drug.disease(refmatrix=samplematrix,inputmatrix=rankdatainv,lengthtest=downlength)
		PscoreDownref<-.KS.drug.disease(refmatrix=rankdata,inputmatrix=samplematrixinv,lengthtest=downlength)
		PscoreDownref<-t(PscoreDownref)
	
		#PscoreUp<-(PermScoreup$input_ref+PermScoreup$input_ref)/2
		#PscoreDown<-(PermScoredown$ref_input+PermScoredown$ref_input)/2
		
	
		
		score1<-(PermScoreup-PermScoredown)/2
		score2<-(PscoreUpref-PscoreDownref)/2
		
		check1<-sign(PermScoreup)==sign(PermScoredown)
		check2<-sign(PscoreUpref)==sign(PscoreDownref)
		
		score1[check1]<-0
		score2[check2]<-0		
		
		#PscoreUp<-(PermScoreup$input_ref+PermScoreup$input_ref)/2
		#PscoreDown<-(PermScoredown$ref_input+PermScoredown$ref_input)/2
		
		Pscores<-score1+score2
		Pscores<-Pscores/2
		
		
		#if(combine=="mean"){
				
		#	Pscore<-(PscoreUp+PscoreDown)/2
			
		#}else{
			#combine scores by taking the maximum
			#m<-PscoreUp>PscoreDown
			#Pscore<-PscoreDown
			#Pscore[m]<-PscoreUp[m]
		#	m<-PscoreUp>PscoreDown
		#	Pscore<-PscoreDown
		#	Pscore[m]<-PscoreUp[m]
		#}
	
	}else{
		#using the WSR score (do we want to rank the absolute values?)
		Samplesigns<-sapply(1:noperm,function(x) sample(c(-1,1),size=size,replace=TRUE))
		samplemat<-smatrix*Samplesigns
		rownames(samplemat)<-rownames(rankdata)
		Pscores<-.WSR(refmatrix=samplemat,inputmatrix=rankdata,uplength=uplength,downlength=downlength)
		
		
	}	
		#now check for significance
		#scores are the vector of ES of the input profile(s) versus the reference data set
		#Pscore contains the scores of the input profiles(s) versus the random perturbation data
		#need to separate positive and negative
		#score is always passing one input profile at a time
#ecdfspos<-ecdf(Pscores[which(Pscores>0)])
#		ecdfsneg<-ecdf(Pscores[which(Pscores<0)])
		
		empcdf<-ecdf(abs(Pscores))
		#get the empirical p-value for the actual scores based on the empirical cdf
		emppvals<-vector(length=length(scores))
#     
#        	scorespos<-1-ecdfspos(scores)
#        	scoresneg<-ecdfsneg(scores)
#        emppvals<-scorespos
#        emppvals[which(scores<0)]<-scoresneg[which(scores<0)]	
        
        emppvals<-1-empcdf(abs(scores))
		
		#	
      	if(adj=="BH"){
			pvaladj<-p.adjust(emppvals)
      	}else{
      	
      		
      		try(qvals<-qvalue(emppvals))
      		if(class(qvals)[1]=="try-error"){
      			pvaladj<-p.adjust(emppvals)
      			warning('Q-values error, used BH correction instead')
      		}else{
      			pvaladj<-qvals$qvalues	
      		}
      
			
				
     	}
	
	sel<-which(pvaladj<fdr)
	signifcompounds<-scores[sel]
	names(signifcompounds)<-names(scores)[sel]

	return(signifcompounds)
	
}
.classifysinglelinkage <-
function(resultslist,customClusters=NULL,case=c("disease","drug"),no.signif=10){
	#resultslist output from significantES
	#if length(resultslist)>1 then we have dynamic set sizes for the KS score
	case<-match.arg(case)

	Clusterlist<-list(length=length(resultslist))
		for(i in 1:length(resultslist)){		
			SignifScores<-resultslist[[i]]
			#see if SignifScores is a list - i.e. more than one disease proifle
			if(is.list(SignifScores)){
				Clust<-lapply(SignifScores,function(x) .findCluster(x,customClusters=customClusters,case=case,no.signif=no.signif))
				names(Clust)<-names(SignifScores)
			}else{
				#just have one profile:
				Clust<-.findCluster(SignifScores,customClusters=customClusters,case=case,no.signif=no.signif)
			}
			Clusterlist[[i]]<-Clust		
		
		}
		names(Clusterlist)<-names(resultslist)
		
	
	return(Clusterlist)
}
.classifyaveragelinkage <-
function(ESscores,statistic=c("mean","median"),customClusters=NULL,case=c("disease","drug")){
	statistic<-match.arg(statistic)
	case<-match.arg(case)
	
	if(is.list(ESscores)){
		#then we have done dynamic list of k's
		ClusterAssignments<-list(length=length(ESscores))
		for(i in 1:length(ESscores)){
			#now need to see if have more than one disease profile or not:
			scorematrix<-ESscores[[i]]
			if(is.matrix(scorematrix)){
				avgscores<-list(length=nrow(scorematrix))				
				for(j in 1:nrow(scorematrix)){
				avgscores[[j]]<-.averagecluster(scorematrix[j,],statistic=statistic,customClusters=customClusters,case=case)}
				names(avgscores)<-rownames(scorematrix)
			}else{
				avgscores<-.averagecluster(scorematrix,statistic=statistic,customClusters=customClusters)				
			}
			ClusterAssignments[[i]]<-avgscores
		}
		names(ClusterAssignments)<-names(ESscores)
	}else{
		#fixed k
		scorematrix<-ESscores
		if(is.matrix(scorematrix)){
			avgscores<-list(length=nrow(scorematrix))				
				for(j in 1:nrow(scorematrix)){
					avgscores[[j]]<-.averagecluster(scorematrix[j,],statistic=statistic,customClusters=customClusters,case=case)
				}
			names(avgscores)<-rownames(scorematrix)				
		}else{				
			avgscores<-list(length=1)
			avgscores<-.averagecluster(scorematrix,statistic=statistic,customClusters=customClusters)
			names(avgscores)<-names(scorematrix)
		}
			ClusterAssignments<-avgscores
				
	}
	#This function always returns a list
	return(ClusterAssignments)
}
.findCluster <-
function(SignifScores,customClusters=NULL,case=c("disease","drug"),no.signif=10){
	case<-match.arg(case)
	#check that we have some significant results otherwise return na
	if(length(SignifScores)==0) return(NA)
	if(is.character(SignifScores))return(NA)
	#check if there are more significant results than have been asked to assign to a cluster
	if(length(SignifScores)>no.signif){cat(paste('Number of Significant results greater than',no.signif, 'Using top' ,no.signif, 'hits - consider using average linkage instead'),fill=TRUE)}
	
	#order by most significant resuts (i.e. the highest absolute Enrichment scores) and take the top no.signif to classify
	absscores<-abs(SignifScores)
	SortScores<-sort(absscores,TRUE)
	SScores<-SignifScores[names(SortScores)]
	SignifScores<-SScores[1:no.signif]
	#load default clusters if customClusters is null, according to whether the input profile was a disease or a drug profile.
	if(is.null(customClusters)){
		
		if(case=="disease"){
			data(drugClusters,package="cMap2data")
			Clusters<-drugClusters
		}else{
			data(diseaseClusters,package="DrugVsDiseasedata")
			Clusters<-diseaseClusters
		}
				 
	}else{
		Clusters=customClusters
		cnames<-colnames(Clusters)
		#check the format of the customClusters
		s1<-which(cnames=="Drug")
		s2<-which(cnames=="Disease")
		if(length(s1)+length(s2)==0){stop('customClusters must contain a column with either "Drug" or "Disease" profiles')}
	}
	signifnames<-names(SignifScores)
	#find the cluster for the significant matches, and output to data frame along with the distance between profiles (1-ES), and name of the profile.
	if(case=="disease"){
		sel<-sapply(signifnames,function(x) which(Clusters[,"Drug"]==x))
		sel<-unlist(sel)
		scores<-SignifScores[names(sel)]
		#distscores<-1-abs(scores)
		distscores<-1-abs(scores)
		#are comparing inverted profiles, so positive scores indicate negative correlation and vice versa 
		
		cors<-ifelse(scores>0,-1,1)
		results.clust<-data.frame(names(sel),distscores,Clusters[sel,"Cluster"],cors)
		colnames(results.clust)<-c("Drug","ES Distance","Cluster","RPS")
	}else{
		sel<-sapply(signifnames,function(x) which(Clusters[,"Disease"]==x))
		sel<-unlist(sel)
		scores<-SignifScores[names(sel)]
		#distscores<-1-abs(scores)
		distscores<-1-abs(scores)
		
		cors<-ifelse(scores>0,-1,1)
		results.clust<-data.frame(names(sel),distscores,Clusters[sel,"Cluster"],cors)
		colnames(results.clust)<-c("Disease","ES Distance","Cluster","RPS")
	}
		
return(results.clust)
	
}
.averagecluster <-
function(scores,statistic="mean",customClusters=NULL,case=c("disease","drug"),stat){
	case<-match.arg(case)
	#load default clusters if customClusters is null
	if(is.null(customClusters)){
	
		if(case=="disease"){
			data(drugClusters,package="cMap2data")
			Clusters<-drugClusters
			}else{
			data(diseaseClusters,package="DrugVsDiseasedata")
			Clusters<-diseaseClusters
			}
				 
	}else{
		Clusters=customClusters
	}
	#get the number of clusters available
	clusternumbers<-unique(Clusters[,"Cluster"])
	numberclusters<-length(clusternumbers)
	avgscores<-rep(0,numberclusters)
	medscores<-rep(0,numberclusters)
	avgscoresneg<-rep(0,numberclusters)
	medscoresneg<-rep(0,numberclusters)
	scorepos<-scores>0
	#for each cluster calculate the mean and median scores
	for(k in 1:numberclusters){
		if(case=="disease"){
			selc<-Clusters[which(Clusters[,"Cluster"]==clusternumbers[k]),"Drug"]
		}else{
			selc<-Clusters[which(Clusters[,"Cluster"]==clusternumbers[k]),"Disease"]
			}
			p<-names(scorepos)[scorepos]
			n<-names(scorepos)[!scorepos]
			sp<-selc[selc%in%p]
			sn<-selc[selc%in%n]
		if(length(sp)>0){	
			avgscores[k]<-mean(scores[sp])		
			medscores[k]<-median(scores[sp])
		}
		if(length(sn)>0){
			avgscoresneg[k]<-mean(abs(scores[sn]))
			medscoresneg[k]<-median(abs(scores[sn]))				
		}	
	}
	#now assign to the cluster with the maximum score:
	if(statistic=="mean"){
		cluster<-which.max(avgscores)
		clusterneg<-which.max(avgscoresneg)
	}else{
		cluster<-which.max(medscores)
		clusterneg<-which.max(medscoresneg)
	}
	#now return the scores to elements in the max cluster, sel has the names of the drugs
		if(case=="disease"){
			sel<-Clusters[which(Clusters[,"Cluster"]==clusternumbers[cluster]),"Drug"]
			selneg<-Clusters[which(Clusters[,"Cluster"]==clusternumbers[clusterneg]),"Drug"]	
		}else{
			sel<-Clusters[which(Clusters[,"Cluster"]==clusternumbers[cluster]),"Disease"]
			selneg<-Clusters[which(Clusters[,"Cluster"]==clusternumbers[clusterneg]),"Disease"]
		}
	selscores<-scores[as.character(sel)]
	selscoresneg<-scores[as.character(selneg)]
	distscores<-1-abs(selscores)
	distscoresneg<-1-abs(selscoresneg)
	if(stat=="KS"){
	results<-data.frame(as.character(sel),distscores,rep(clusternumbers[cluster],length(sel)),rep(-1,length(sel)))
	resultsneg<-data.frame(as.character(selneg),distscoresneg,rep(clusternumbers[clusterneg],length(selneg)),rep(1,length(selneg)))}else{
	results<-data.frame(as.character(sel),distscores,rep(clusternumbers[cluster],length(sel)),rep(1,length(sel)))
	resultsneg<-data.frame(as.character(selneg),distscoresneg,rep(clusternumbers[clusterneg],length(selneg)),rep(-1,length(selneg)))
		
		}
	
	#give column names according to whether we have a disease or drug input profile
	if(case=="disease"){
		colnames(results)<-c("Drugs","ES Distance","Cluster","RPS")
		colnames(resultsneg)<-c("Drugs","ES Distance","Cluster","RPS")
	}else{
		colnames(results)<-c("Disease","ES Distance","Cluster","RPS")
		colnames(resultsneg)<-c("Disease","ES Distance","Cluster","RPS")
	}
	return(rbind(results,resultsneg))
}
.getESscores <-
function(diseasematrixup,diseasematrixdown,uplength=250,downlength=250,drugPRLs,stat=c("KS","WSR")){
	stat<-match.arg(stat)

	if(stat=="KS"){
	#get the ranklists and inverse ranked lists for the reference data set (assuming that the reference set is a rank of decreasing order)
	#drugPRLs is in rank decreasing order
	drugPRLs<-abs(drugPRLs)
	ranknamedrugPRLs<-.ranknamemat(drugPRLs,2,TRUE)
	ranknamedrugPRLsb<-.ranknamemat(drugPRLs,2,FALSE)
	#do the "top" of the input profiles to the "bottom" of the reference data set
	upprof<-.KS.drug.disease(refmatrix=ranknamedrugPRLs,inputmatrix=diseasematrixup,lengthtest=uplength)
	upref<-.KS.drug.disease(refmatrix=diseasematrixup,inputmatrix=ranknamedrugPRLs,lengthtest=uplength)
	upref<-t(upref)
	#now compare the "bottom" of the input profiles to the "top" of the reference data set
	downprof<-.KS.drug.disease(refmatrix=ranknamedrugPRLs,inputmatrix=diseasematrixdown,lengthtest=downlength)
	downref<-.KS.drug.disease(refmatrix=diseasematrixup,inputmatrix=ranknamedrugPRLsb,lengthtest=downlength)
	downref<-t(downref)
	
	
	score1<-(upprof-downprof)/2
	score2<-(upref-downref)/2
	
	check1<-sign(upprof)==sign(downprof)
	check2<-sign(upref)==sign(downref)
	score1[check1]<-0
	score2[check2]<-0
	scores<-score1+score2
	#ESinput_ref<-(upprof_ref+downprof_ref)/2
	#TESin_ref<-(upprof_ref+downprof_ref)/2
	#then we have compared the gene sets as defined from the reference profiles to the input profiles as well
	
	#upprof_input<-updiseasedowndrug$ref_input
	#downprof_input<-downdiseaseupdrug$ref_input
	#ESref_input<-(upprof_input+downprof_input)/2
	#TESref_in<-(upprof_input+downprof_input)/2
	
	#combine taking either the mean or the maximum of the scores
	#if(combine=="mean"){
		#all<-(ESinput_ref+ESref_input)/2
	#	all<-(TESin_ref+TESref_in)/2
	#}else{	
		#m<-ESref_input>ESinput_ref
		#all<-ESinput_ref
		#all[m]<-ESref_input[m]
	#	m<-TESref_in>TESin_ref
	#	all<-TESin_ref
	#	all[m]<-TESref_in[m]
	#}

	all<-scores/2
	all<-as.matrix(all)
	

	#all will have the disease profiles as rows and the columns as drugs
	#need to change KS.drug.disease to deal with vectors (i.e one disease profile only)		
	}else{
		#going to do the Gant version instead.
		
		
		all<-.WSR(refmatrix=drugPRLs,inputmatrix=diseasematrixup,uplength=uplength,downlength=downlength)
		all<-as.matrix(all)
		
	}
	
	if(is.matrix(diseasematrixup)){
	rownames(all)<-colnames(diseasematrixup)}
	colnames(all)<-colnames(drugPRLs)
	
	return(all)
	
	
	
}

.WSR<-function(refmatrix,inputmatrix,uplength=250,downlength=250){
	#cant use the refmatrix to inputmatrix with this score as we do not have the DE for the cMap data only the ranks
	#assume that refmatrix and inputmatrix contain the ranked signed profiles (e.g. t or coefs)
	#better to split the data into two for up and down regulated, first rank overall:
	refmatrix<-as.matrix(refmatrix)
	inputmatrix<-as.matrix(inputmatrix)
	N<-nrow(refmatrix)
	m<-uplength+downlength
	inputranksignmat<-apply(inputmatrix,2,function(x) rank(abs(x)))
	refranksignmat<-apply(refmatrix,2,function(x) rank(abs(x)))
	nameinput<-.ranknamemat(inputranksignmat,2,TRUE)
	genesets<-nameinput[1:m,]
	genesets<-as.matrix(genesets)
	#ranks for input, should have max value m (not N) i.e split the data
	
	#rankinput<-seq(lengthtest:1)
	#rankref<-apply(refmatrix,2,rank)
	stat<-matrix(nrow=ncol(inputmatrix),ncol=ncol(refmatrix))
	for(i in 1:ncol(inputmatrix)){
		inputranks<-rank(abs(inputmatrix[genesets[,i],i]))
		
		#refvals<-sign(refmatrix[genesets[,i],])*rankref[genesets[,i],]
		#inputvals<-sign(inputmatrix[genesets[,i],i])*rankinput
		
		inputvals<-inputranks*sign(inputmatrix[genesets[,i],i])
		refvals<-refranksignmat[genesets[,i],]*sign(refmatrix[genesets[,i],])
		statvec<-refvals*inputvals
		stat[i,]<-apply(statvec,2,sum)
		

	}

	maxscore<-sum((N-1:m+1)*(m-1:m+1))

	stat<-stat/maxscore
	#*-1 to invert the scores to be consistent with the KS scores, just for reporting the RPS sign at the end. To clean up later.
	return(stat*-1)
	
}
.KS.drug.disease <-
function(refmatrix,inputmatrix,lengthtest=250){
	
	
	refmatrix<-as.matrix(refmatrix)
	inputmatrix<-as.matrix(inputmatrix)
	N<-lengthtest
	Nh<-nrow(refmatrix)
	nototest<-ncol(inputmatrix)
	#outmat<-matrix(nrow=nototest,ncol=ncol(refmatrix))
	#outmat2<-matrix(nrow=nototest,ncol=ncol(refmatrix))
	outmat<-c()
	#outmat2<-c()
	for(i in 1:nototest){
		
		#for a particular disease signature
		toptail<-inputmatrix[1:lengthtest,i]
		#toptoref contains the references of elements in the refmatrix which are in the gene set of the input profile
		toptoref<-refmatrix%in%toptail


		In<-matrix(0,nrow=nrow(refmatrix),ncol=ncol(refmatrix))
		Out<-matrix(0,nrow=nrow(refmatrix),ncol=ncol(refmatrix))
		#assing 1/N to those elements in the gene set and 1/(Nh-N) to those which are not
		In[toptoref]<-1/N
		Out[!toptoref]<-1/(Nh-N)
		#calculate the cumulative (running sums)
		if(ncol(refmatrix)==1){
				In<-as.matrix(In,ncol=1)
				Out<-as.matrix(Out,ncol=1)
				
		}
		
		In<-apply(In,2,cumsum)
		Out<-apply(Out,2,cumsum)
		#take the difference to get the running Enrichment scores
		Testmat<-In-Out
		#take the maxium as the final enrichment score
		refvalues<-apply(Testmat,2,function(x) x[which.max(abs(x))])
		#outmat[i,]<-apply(Testmat,2,max)
		#outmat[i,]<-refvalues
		outmat<-rbind(outmat,refvalues)
	}
	
		#if we are also comparing the gene sets from the reference data to the input profiles
		#for(j in 1:ncol(refmatrix)){
		
		#	toptail<-refmatrix[1:lengthtest,j]
		#	toptoinput<-inputmatrix%in%toptail
		#	In<-matrix(0,nrow=nrow(refmatrix),ncol=ncol(inputmatrix))
		#	Out<-matrix(0,nrow=nrow(refmatrix),ncol=ncol(inputmatrix))

		#	In[toptoinput]<-1/N
		#	Out[!toptoinput]<-1/(Nh-N)
			
			#in case there is only one reference profile being classified
		#	if(ncol(inputmatrix)==1){
		#		In<-as.matrix(In,ncol=1)
		#		Out<-as.matrix(Out,ncol=1)
				
		#	}
		#	In<-apply(In,2,cumsum)
		#	Out<-apply(Out,2,cumsum)
		#	Testmat<-In-Out
			#outmat2[,j]<-apply(Testmat,2,max)
		#	refvalues2<-apply(Testmat,2,function(x) x[which.max(abs(x))])
			#outmat2[,j]<-refvalues2
		#	outmat2<-cbind(outmat2,refvalues2)
		#}
		#rownames(outmat2)<-colnames(inputmatrix)
		#colnames(outmat2)<-colnames(refmatrix)

	
	
	rownames(outmat)<-colnames(inputmatrix)
	colnames(outmat)<-colnames(refmatrix)
	
	#return(list(input_ref=outmat,ref_input=outmat2))
	return(outmat)
}
.ranknamemat <-
function(matrix,ref,decreasing){
		#rank the matrix, returning the names, starting with the most signif
		
			#want to start with largest first (e.g. rank expression values) 
			if(is.matrix(matrix)){
			rankedmat<-apply(matrix,ref,function(x) names(x)[sort.list(as.integer(x),decreasing=decreasing,method="radix")])
			}else{
				rankedmat<-names(sort(matrix,decreasing=decreasing))
			}
		#output is a vector or matrix of ranked lists sorted according to parameter 'decreasing' and with rank values replaced by their names
		return(rankedmat)
		
}
.writecytoscape <-
function(case=c("disease","drug"),clusterassignments,filename,customsif=NULL,customedge=NULL,nodename=NULL,customClusters=NULL){
	
	case<-match.arg(case)


	#load default networks and generate SIF and Edge attribute files if custom networks have not been provided
	if(!is.null(customsif)){
		networksif=customsif
		cytoedge=customedge
		RPS<-cytoedge
		RPS[,5]<-1
		if(case=="disease"){
			nodetype<-data.frame(cbind(unique(as.character(RPS[,1])),rep("=",length(unique(RPS[,1]))),rep("drug",length(unique(RPS[,1])))))
			
		}else{
			nodetype<-data.frame(cbind(unique(as.character(RPS[,1])),rep("=",length(unique(RPS[,1]))),rep("disease",length(unique(RPS[,1])))))
			}
			
		Clusters<-customClusters
		labels<-NULL
	}else{
		if(case=="disease"){
			data(cytodrug,package="cMap2data")
			data(drugClusters,package="cMap2data")
			Clusters<-drugClusters
			cytooutput<-cytodrug
			nodetype<-data.frame(cbind(as.character(Clusters[,1]),rep("=",nrow(Clusters)),rep("drug",nrow(Clusters))))
			data(druglabels,package="cMap2data")
			labels<-druglabels
		}else{
			data(cytodisease,package="DrugVsDiseasedata")
			data(diseaseClusters,package="DrugVsDiseasedata")
			Clusters<-diseaseClusters
			nodetype<-data.frame(cbind(as.character(Clusters[,1]),rep("=",nrow(Clusters)),rep("disease",nrow(Clusters))))
			cytooutput<-cytodisease
			data(diseaselabels,package="DrugVsDiseasedata")
			labels<-diseaselabels
			
		}
		#create SIF format of nodename1,1,nodename2. N.B. the edge type is always 1
		suppressWarnings(networksif<-data.frame(cbind(as.character(cytooutput[,1]),rep(1,nrow(cytooutput)),as.character(cytooutput[,2]))))
		#create edge attribute file: nodename1, "(1)", nodename2, "=", Distance between node1 and node2
		suppressWarnings(cytoedge<-data.frame(cbind(as.character(cytooutput[,1]),rep("(1)",nrow(cytooutput)),as.character(cytooutput[,2]),rep("=",nrow(cytooutput)),as.character(cytooutput[,3]))))
		suppressWarnings(RPS<-data.frame(cbind(as.character(cytooutput[,1]),rep("(1)",nrow(cytooutput)),as.character(cytooutput[,2]),rep("=",nrow(cytooutput)),as.character(cytooutput[,4]))))
	
		
	}
	cytonode<-as.data.frame(cbind(as.character(Clusters[,1]),rep("=",nrow(Clusters)),Clusters[,2]))	
	#create the sif, edge files for the reference network
	edgeheader<-vector(mode="character",length=5)
	edgeheader[1]<-"Distance"
	nodeheader<-vector(mode="character",length=3)
	nodeheader[1]<-"ClusterID"
	#RPS = Running-sum Peak Sign
	nodetypeheader<-vector(mode="character",length=3)
	nodetypeheader[1]<-"NodeType"
	RPSheader<-vector(mode="character",length=5)
	RPSheader[1]<-"RPS"
	write.table(networksif,file=paste(filename,"network.sif",sep="_"),quote=FALSE,na="",row.names=FALSE,col.names=FALSE)
	write.table(cytoedge,file=paste(filename,"Distance.EA",sep="_"),quote=FALSE,na="",row.names=FALSE,col.names=edgeheader)
	write.table(cytonode,file=paste(filename,"Cluster.noa",sep="_"),quote=FALSE,na="",row.names=FALSE,col.names=nodeheader)
	write.table(RPS,file=paste(filename,"RPS.EA",sep="_"),quote=FALSE,na="",row.names=FALSE,col.names=RPSheader)
	write.table(nodetype,file=paste(filename,"NodeType.noa",sep="_"),quote=FALSE,na="",row.names=FALSE,col.names=nodetypeheader)
	
	signifmatches<-clusterassignments
	#for the significant matches and genereate the sif and edge information
	allnames<-c()
	inputsif<-c()
	inputedge<-c()
	inputRPS<-c()
	for(i in 1:length(signifmatches)){
		res<-signifmatches[[i]]
		if(!is.data.frame(res)){

			for(j in seq(length=length(res))){
				t<-as.matrix(res[[j]])
				if(!is.null(t)){
					nodename=paste(names(signifmatches)[i],names(res)[[j]],sep="_")
					m<-data.frame(cbind(rep(nodename,nrow(t)),as.character(t[,1])))
					inputsiftemp<-data.frame(cbind(as.character(m[,1]),rep(1,nrow(m)),as.character(m[,2])))	
					inputedgetemp<-data.frame(cbind(as.character(m[,1]),rep("(1)",nrow(m)),as.character(m[,2]),rep("=",nrow(m)),t[,2]))
					inputRPStemp<-data.frame(cbind(as.character(m[,1]),rep("(1)",nrow(m)),as.character(m[,2]),rep("=",nrow(m)),t[,4]))
					colnames(inputsiftemp)<-colnames(networksif)
					colnames(inputedgetemp)<-colnames(cytoedge)
					colnames(inputRPStemp)<-colnames(cytoedge)
					allnames<-c(allnames,nodename)
				}
				inputsif<-rbind(inputsif,inputsiftemp)
				inputedge<-rbind(inputedge,inputedgetemp)
				inputRPS<-rbind(inputRPS,inputRPStemp)
			}
			
		}else{
			nodenames<-names(signifmatches)
			allnames<-c(allnames,nodenames)
			if(!is.null(res)){
				res<-as.matrix(res)
				m<-data.frame(cbind(rep(nodename[i],nrow(res)),as.character(res[,1])))
				inputsiftemp<-data.frame(cbind(as.character(m[,1]),rep(1,nrow(m)),as.character(m[,2])))
				inputedgetemp<-data.frame(cbind(as.character(m[,1]),rep("(1)",nrow(m)),as.character(m[,2]),rep("=",nrow(m)),res[,2]))
				inputRPStemp<-data.frame(cbind(as.character(m[,1]),rep("(1)",nrow(m)),as.character(m[,2]),rep("=",nrow(m)),res[,4]))
				colnames(inputsiftemp)<-colnames(networksif)
				colnames(inputedgetemp)<-colnames(cytoedge)
				colnames(inputRPStemp)<-colnames(cytoedge)

			}
		}
		inputsif<-rbind(inputsif,inputsiftemp)
		inputedge<-rbind(inputedge,inputedgetemp)
		inputRPS<-rbind(inputRPS,inputRPStemp)
		
	}
	#cluster for new nodes:
	inputnode<-data.frame(cbind(unique(as.character(allnames)),rep("=",length(unique(allnames))),rep(0,length(unique(allnames)))))
	inputNT<-data.frame(cbind(unique(as.character(allnames)),rep("=",length(unique(allnames))),rep(case,length(unique(allnames)))))
	colnames(inputnode)<-colnames(cytonode)
	#append edges and attributes of the input profiles to nodes in the reference set file.
	write.table(inputsif,file=paste(filename,"network.sif",sep="_"),quote=FALSE,na="",row.names=FALSE,col.names=FALSE,append=TRUE)
	write.table(inputedge,file=paste(filename,"Distance.EA",sep="_"),quote=FALSE,na="",row.names=FALSE,col.names=FALSE,append=TRUE)
	write.table(inputnode,file=paste(filename,"Cluster.noa",sep="_"),quote=FALSE,na="",row.names=FALSE,col.names=FALSE,append=TRUE)
	write.table(inputRPS,file=paste(filename,"RPS.EA",sep="_"),quote=FALSE,na="",row.names=FALSE,col.names=FALSE,append=TRUE)
	write.table(inputNT,file=paste(filename,"NodeType.noa",sep="_"),quote=FALSE,na="",row.names=FALSE,col.names=FALSE,append=TRUE)
	if(!is.null(labels)){
		#now do the mapping for the drug/disease urls
		labels<-data.frame(cbind(as.character(labels[which(labels[,1]%in%Clusters[,1]),1]),rep("=",length(unique(allnames))),as.character(labels[which(labels[,1]%in%Clusters[,1]),2])))
		nulllabels<-data.frame(cbind(unique(as.character(allnames)),rep("=",length(unique(allnames))),rep(NA,length(unique(allnames)))))
		colnames(nulllabels)<-colnames(labels)
		labelout<-rbind(labels,nulllabels)
		lname<-vector(mode="character",length=3)
		lname[1]<-"NodeURL"
		write.table(labelout,file=paste(filename,"NodeURL.noa",sep="_"),quote=FALSE,row.names=FALSE,col.names=lname)
		
	}
	
}
.combineEnsembl <-
function(data,annotation,genelist,type=c("average","medpolish","maxvar")){
  	#remove probes which map to more than one gene...
	countprobe<-table(annotation[,1])
	selp<-names(which(countprobe==1))
	data<-as.matrix(data[selp,])
	annotation<-annotation[which(annotation[,1]%in%selp),]
	#find out how many probes map to a given gene
	countgene<-table(annotation[,2])
	#find all those which are 1-1 probe-gene mappings
	sel<-names(which(countgene==1))
	probes<-annotation[which(annotation[,2]%in%sel),1]
	temp<-as.matrix(data[probes,])
	rownames(temp)<-annotation[which(annotation[,2]%in%sel),2]
	#find those which are not a 1-1 mapping
	combinegenes<-names(which(countgene!=1))
	subdata<-as.matrix(data[-(which(rownames(data)%in%probes)),])
	subannot<-annotation[which(annotation[,1]%in%rownames(subdata)),]
	#sort data according to the genes they map to
	sorder<-subannot[order(subannot[,2]),]
	sdorder<-subdata[sorder[,1],]
  	sdorder<-as.matrix(sdorder)
	tabann<-table(sorder[,2])
	#combine results where there is not a 1-1 mapping
	if(type=="average"){
		other<-.combined(tabann,sdorder)}
	if(type=="medpolish"){
		other<-.combinemed(tabann,sdorder)
	}
	if(type=="maxvar"){
		cumulativecount<-cumsum(tabann)
		other<-.maxvar(sdorder,cumulativecount)
	}
	if(type=="max"){
		other<-convertProbes(subdata,subannot)
	}
	rownames(other)<-combinegenes
	d<-rbind(temp,other)
	l1<-length(which(rownames(d)%in%genelist))
	if(l1!=length(genelist)){cat('Note: Ensembl genes do not match genelist in reference data. Consider uploading pre-processed lists to classifyprofiles',fill=TRUE)}
	d[which(rownames(d)%in%genelist),]
}
.combined <-
function(tabann,sdorder){
	
	refs<-cumsum(tabann)
	other2<-matrix(nrow=(length(tabann)-1),ncol=ncol(sdorder))
  	if(ncol(sdorder)==1){
  	  other<-mean(sdorder[1:refs[1],])
      for(i in 2:length(tabann)){
    	  other2[i-1,]<-mean(sdorder[(refs[i-1]+1):refs[i],]) 
      }
   	}else{
   	  other<-colMeans(sdorder[1:refs[1],])
  	  for(i in 2:length(tabann)){
		  other2[i-1,]<-colMeans(sdorder[(refs[i-1]+1):refs[i],])
		
	  }
   }
	colnames(other2)<-colnames(sdorder)
	
	rbind(other,other2)
}
.combinemed<-
function(tabann,sdorder){
	
	refs<-cumsum(tabann)
	other2<-matrix(nrow=(length(tabann)-1),ncol=ncol(sdorder))
  	if(ncol(sdorder)==1){
  	  mfit<-medpolish(sdorder[1:refs[1],])
  	  other<-mfit$overall+mfit$col
      for(i in 2:length(tabann)){
      	  mfit<-medpolish(sdorder[(refs[i-1]+1):refs[i],])
    	  other2[i-1,]<-mfit$overall+mfit$col 
      }
   	}else{
   		mfit<-medpolish(sdorder[1:refs[1],])
   	  other<-mfit$overall+mfit$col
  	  for(i in 2:length(tabann)){
  	  	  mfit<-medpolish(sdorder[(refs[i-1]+1):refs[i],])
		  other2[i-1,]<-mfit$overall +mfit$col
		
	  }
   }
	colnames(other2)<-colnames(sdorder)
	
	rbind(other,other2)
}

.matrixVar <- function(x) {
  x <- as.matrix(x)
  n <- ncol(x)
  v <- (((x * x) %*% matrix(rep(1, n), nrow=n)) - n * rowMeans(x) * rowMeans(x))/(n - 1)
  v[v < 0] <- 0
  v
}
.maxvar<-function(probevals,cumulativecount){
	
	maxvar<-vector(length=length(cumulativecount))
	maxvar[1]<-rownames(probevals)[which.max(.matrixVar(probevals[1:cumulativecount[1],]))]
	for(i in 2:length(cumulativecount)){
		rnames<-rownames(probevals)[(cumulativecount[i-1]+1):cumulativecount[i]]
		maxvar[i]<-rnames[which.max(.matrixVar(probevals[(cumulativecount[i-1]+1):cumulativecount[i],]))]
	}
	return(probevals[maxvar,])
}
convertProbes<-function(subdata,subannot){
	

	#sort data according to the genes they map to
	#sorder<-subannot[order(subannot[,2]),]
	#sdorder<-subdata[sorder[,1],]
  	#sdorder<-as.matrix(sdorder)
  	annot<-subannot[,2]
  	nexps<-ncol(subdata)
  	noprobes<-nrow(subdata)
  	check1<-subdata[,1:nexps]<(noprobes/2)
	data1<-subdata[,1:nexps]-(noprobes/2)
	data2<-(noprobes/2)-subdata[,1:nexps]
	outranks<-data1[,1:nexps]
	outranks[check1]<-data2[check1]
  	
	out<-apply(outranks,2,function(x) .ptog(x,annot))
		
}

.ptog<-function(data,annot){
	d<-data.frame(cbind(data,annot))
	colnames(d)<-c("data","gene")
	v<-d$gene[i<-order(d$data)]
	ind<-!duplicated(v,fromLast=TRUE)
	idx<-setNames(seq_len(nrow(d))[i][ind],v[ind])
	data<-data[idx]
	names(data)<-names(idx)
	data<-data[order(names(idx))]
	
}




.convertEnsembl <-
function(annotation,values){
	#values should be the list of probes for the selected platform
	sel<-which(annotationlist[,1]==annotation)
	if(length(sel)==0){
		pgmat<-matrix(c("pd.hg.u133a", "affy_hg_u133a", "pd.hg.u133.plus.2", "affy_hg_u133_plus_2", "pd.hg.u133a.2", "affy_hg_u133a_2"),nrow=3,ncol=2,byrow=TRUE)
		sel<-which(pgmat[,1]==annotation)
	}
	if(length(sel)==0){stop('Annotation file not available for this platform. Must be one of Affymetrix, HGU133A, HGU133A2 or HGU133Plus2. Alternatively upload an annotation file to process the data')}
	annref<-annotationlist[sel,2]
	human_mart<-useMart(biomart="ENSEMBL_MART_ENSEMBL",dataset="hsapiens_gene_ensembl",host="www.ensembl.org")
	annotation_ensembl<-getBM(attributes=c(annref,"hgnc_symbol"),filters=annref,values=values,mart=human_mart)
	#this will be a matrix each attributes are columns rows are values
	return(cbind(annotation_ensembl[[1]],annotation_ensembl[[2]]))
	
}
.fitlms <-
function(normalised,experimentAEpdata=NULL,customfactors=NULL,experiment=NULL,case=c("disease", "drug"),statistic=c("coef", "t","diff")){
		
		case<-match.arg(case)
		statistic<-match.arg(statistic)
		
		#if statistic chosen is diff, simply remove logarithms and use the standard linear model coefficients
		if(statistic=="diff"){
			normalised<-2^(normalised)
			statistic<-"coef"
		}
		
					
			if(is.null(customfactors)){
				if(is.null(experimentAEpdata)){stop("No factor data provided in either experimentAEpdata or customfactors")}
				#find available factors from the meta data
				factorvals<-grep("Factor.Value",ignore.case=TRUE,colnames(experimentAEpdata),value=T)
				if(length(factorvals)==0){factorvals<-grep("FactorValue",ignore.case=TRUE,colnames(experimentAEpdata),value=T)}
				if(length(factorvals)==0){stop("No Factor Values found in the pData. Check the Array Express entry and consider using the customfactors to supply factor values.")}
				if(case=="disease"){
					factordisease<-grep("state",ignore.case=TRUE,factorvals,value=T)
					if(length(factordisease)==0)factordisease<-grep("status",ignore.case=TRUE,factorvals,value=T)
                    if(length(factordisease)==0)factordisease<-grep("disease",ignore.case=TRUE,factorvals,value=T)
				}else{
						factordisease<-grep("compound",ignore.case=TRUE,factorvals,value=T)
                        if(length(factordisease)==0)factordisease<-grep("dose",ignore.case=TRUE,factorvals,value=T)
				}
				
				
				if(length(factordisease)==0){
					fv<-c()
					for(i in 1:length(factorvals)){
						fv<-paste(fv,factorvals[i])	
					}
					stop(paste("No disease factor present for experiment, use customfactors to provide one. Available factor values are:",fv))
				}
					factors<-experimentAEpdata[,factorvals]
					numberfactors<-length(factorvals)
					factor<-experimentAEpdata[,factordisease]
					factor<-as.vector(factor)
			
			}else{
				#using customfactors from local made file		
				#if option passed is a character string, assume this is a file path:
				if(is.character(customfactors))customfactors<-read.table(customfactors,header=TRUE)
				#if it is an R data object then extract factor values based on column names:
				if(is.matrix(customfactors)){
					factorvals<-colnames(customfactors)
				}else{
					factorvals<-names(customfactors)
				}
				factors<-customfactors
				#find the "main" explanatory factor
				if(case=="disease"){
					factordisease<-grep("disease",ignore.case=TRUE,factorvals,value=T)
				}else{
					factordisease<-grep("compound",ignore.case=TRUE,factorvals,value=T)
				}
				
				factorfiles<-grep("CEL",ignore.case=TRUE,factorvals,value=T)
				if(length(factorfiles)==0){stop("No CEL file factor present for imported data, check custom factors")}
				if(length(factordisease)==0){stop("No disease/compound factor present for experiment, check custom factors")}
				if(length(factordisease)>1){stop("More than one disease/compound factor found, check custom factors")}
				if(length(factorfiles)>1){warning("More than one CEL file name factor found")}
				#make sure the factors match the order the files will have been read in from the directory by ReadAffy:
				
				factors<-customfactors[order(customfactors[,factorfiles]),]
				factor<-as.vector(factors[,factordisease])
				factors<-factors[,-which(factorvals==factorfiles)]
				factorvals<-factorvals[-which(factorvals=="CEL")]
				numberfactors<-length(factorvals)
				
			}
			
			if(length(unique(factor))<2){
				fv<-c()
				for(i in 1:length(factorvals)){
					fv<-paste(fv,factorvals[i])
				}
	
stop(paste("Disease/Compound factor has less than 2 levels, available factors are:",fv))}
			
			if(!is.factor(factor)){factor<-factor(factor)}
			#generate the main explanatory factore design matrix
			suppressWarnings(designdisease<-model.matrix(~0+factor))
			colnames(designdisease)<-make.names(colnames(designdisease))
			nlevdisease<-nlevels(as.factor(factor))

			design<-c()
			cnames<-c()
			ranklist<-c()
			pvalues<-c()
			factstoinc<-0
		#stratify the main factor according to additional factors present and check if there are enough replicates at each level to fit a linear model
		if(numberfactors>1){
			fref<-which(factorvals==factordisease)
			factnodisease<-as.matrix(factors[,-fref])
			colnames(factnodisease)<-colnames(factors)[-fref]
			factlevstoinc<-vector("list",length=(numberfactors-1))
			factornames<-colnames(factnodisease)
			for(i in 1:(numberfactors-1)){
				
				if(numberfactors>2){
					factorcount<-table(factor,factnodisease[,i])
				}else{
					factorcount<-table(factor,factnodisease)
				}
				minreps<-apply(factorcount,2,min)
				#check have at least 2 replicates
				tu<-which(minreps>1)
				if(length(tu)>0){
					
					factstoinc<-factstoinc+1
					factlevstoinc[[factstoinc]]<-colnames(factorcount)[tu]
					if(is.matrix(factnodisease))factornames[factstoinc]<-colnames(factnodisease)[i]	
				}
				
			}
			names(factlevstoinc)<-factornames
		}
		

		#if there are additional factors to stratify the data by:
			if(factstoinc>0){
			
				
					for(i in seq(length=factstoinc,by=1)){
						if(i>1){
							#store the names of the contrasts
							ncur<-colnames(ranklist)
						}
						#extract the additional factor to be used in the linear model
						uniquefac<-factlevstoinc[[i]]	
	
						nlev<-length(uniquefac)
						cnames<-c()
						for(j in 1:nlev){
							#for each level of the second factor
							if(is.double(normalised)){vec<-vector(length=ncol(normalised))}else{
							vec<-vector(length=dim(normalised)["Samples"])}
							if(is.matrix(factnodisease)){
							#create a vector to store whether or not a replicate (sample) is to be included
							vec[which(factnodisease[,names(factlevstoinc)[i]]==uniquefac[j])]<-1}else{vec[which(factnodisease==uniquefac[j])]<-1}
							#create the sub design matrix
							designtouse<-designdisease*vec
							#fit the linear model
							lmodel<-lmFit(normalised,designtouse)
						
							#fit all available contrasts according to the number of levels of the main factor
							if(nlevdisease>2){
								
								rl<-try(.multcontrast(nlevdisease,designtouse,lmodel,expname=uniquefac[j],statistic=statistic))
								if(class(rl)[1]=="try-error"){warning(paste("Linear model failed for factor",uniquefac[j]))}
								#cnames<-c(cnames,colnames(rl$ranks))
								ranklist<-cbind(ranklist,rl$ranks)
								pvalues<-cbind(pvalues,rl$pvalues)
							}
							else{
								#try making contrast matrix by hand instead and search for "normal" keyword in disease factor
								
								rl<-try(.singlecontrast(normalised,designtouse,expname=uniquefac[j],statistic=statistic))
								if(class(rl)[1]=="try-error"){warning(paste("Linear model failed for factor",uniquefac[j]))}
								#need to do the other outputs e.g. SAM, Q-values, p-values
								ranklist<-cbind(ranklist,rl$ranks)
								pvalues<-cbind(pvalues,rl$pvalues)
								
							}
										
						}	
						
					}
					#now do for main factor only
					rl<-.treatmentonlyfit(nlevdisease,normalised,designdisease,factor,expname="all",statistic=statistic)
					
					ncur<-colnames(ranklist)
					ranklist<-cbind(ranklist,rl$ranks)
					pvalues<-cbind(pvalues,rl$pvalues)
					
					colnames(ranklist)<-c(ncur,colnames(rl$ranks))
					colnames(pvalues)<-c(ncur,colnames(rl$ranks))
								
				}else{
				#have no subtypes to do only the main factor				
					rl<-.treatmentonlyfit(nlevdisease,normalised,designdisease,factor,expname="all",statistic=statistic)		
					ranklist<-rl$ranks
					pvalues<-rl$pvalues			
				}
		
		
		return(list(ranklist=ranklist,pvalues=pvalues))
}
.treatmentonlyfit <-
function(nlevdisease,normalised,designdisease,factor,expname,statistic){
	
	if(nlevdisease>2){
		#fit multiple level contrasts.
		lmodel<-lmFit(normalised,designdisease)
		rl<-try(.multcontrast(nlevdisease,factor,lmodel,expname=expname,statistic=statistic))
		if(class(rl)[1]=="try-error")stop("Unable to fit the linear model, check data inputs")
		rt<-rl$ranks
		pvalues<-rl$pvalues

								
		}else{
			#assume have case/control
			ranklist<-try(.singlecontrast(normalised,designdisease,expname=expname,statistic=statistic))
			if(class(ranklist)[1]=="try-error")stop("Unable to fit the linear model, check data inputs")
			rt<-ranklist$ranks
			pvalues<-ranklist$pvalues
		
		}

	return(list(ranks=rt,pvalues=pvalues))	
	
}
.singlecontrast <-
function(normalised,designdisease,expname,statistic){
		#fit model of DE between case and control for the main factor
		fit<-lmFit(normalised,designdisease)
		#do both possible contrasts (case-control and control-case)
		contrdisease<-c(1,-1)
		contrdisease<-rbind(contrdisease,c(-1,1))
		rownames(contrdisease)<-colnames(designdisease)
		fit2<-contrasts.fit(fit,contrdisease)
		coefs<-fit2$coefficients
		#do empirical bayes procedure from limma, and extract either logFC (coefficients) or t-statistic (t)
		fite<-eBayes(fit2)
		if(statistic=="coef"){
			ranklist<-fite$coefficients
		}else{
			ranklist<-fite$t
		}
		#get the corresponding pvalues
		pvalues<-fite$p.value
		#set the names for each of the contrasts
		cnames<-c(paste(colnames(designdisease)[1],"-",colnames(designdisease)[2],":",expname,sep=""),paste(colnames(designdisease)[2],"-",colnames(designdisease)[1],":",expname,sep=""))
		colnames(ranklist)<-cnames
		colnames(pvalues)<-cnames
				
		return(list(ranks=ranklist,pvalues=pvalues))
	
}
.multcontrast <-
function(nlevdisease,factor,lmodel,expname,statistic){
		#find all combinations of two levels of the main factor
		nocombs<-choose(nlevdisease,2)
		contrmat<-matrix(0,nrow=nocombs,ncol=nlevdisease)
		colnames(contrmat)<-colnames(lmodel$coefficients)
		combinations<-combn(colnames(lmodel$coefficients),2)
		#generate the contrasts for each possible combination
		for(k in 1:nocombs){
			contrmat[k,combinations[1,k]]<-1
			contrmat[k,combinations[2,k]]<-(-1)
		}
		
		fullcontrmat<-rbind(contrmat,contrmat*(-1))
		fullcontrmat<-t(fullcontrmat)
		#fit the contrasts and do empirical bayes from limma
		fitfull<-contrasts.fit(lmodel,fullcontrmat)
		modele<-eBayes(fitfull)
		#extract either log FC (coefficient) or the t-statistic (t)
		if(statistic=="coef"){
			ranklist<-modele$coefficients
		}else{
			ranklist<-modele$t
		}
		#get the pvalues
		pvalues<-modele$p.value
		cnames1<-paste(combinations[1,],"-",combinations[2,],":",expname,sep="")
		cnames2<-paste(combinations[2,],"-",combinations[1,],":",expname,sep="")
		colnames(ranklist)<-c(cnames1,cnames2)
		colnames(pvalues)<-c(cnames1,cnames2)
		return(list(ranks=ranklist,pvalues=pvalues))
									
}

.mrs = function(platform1.data, platform2.data, p1.names=0, p2.names=0, skip.match = FALSE){
######################################################################
#Copyright Jason Rudy & Faramarz Valafar 2009-2010
	
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
	
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
	
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.
######################################################################
	
######################################################################
#This file contains code adapted from the WebArrayDB program,
#available from http://www.webarraydb.org/webarray/index.html  Please 
#cite appropriately when using these functions.  Type 
#citation("CONOR") at the R prompt for details.
	
	
#Implements the median rank scores algorithm for cross
#platform normalization.
	

	#This function is basically a wrapper for normalizeGQ
	
	#Match names
	input = .processplatforms(list(x=platform1.data,y=platform2.data),namesvec = c(p1.names, p2.names), skip.match=skip.match)
	
	#Prepare for normalizeGQ
	combined = cbind(input$x,input$y)
	pf = c(seq(1,1,length.out=dim(input$x)[2]),seq(2,2,length.out=dim(input$y)[2]))
	
	#Call normalizeGQ
	nmrs = .norm_mrs(combined,pf)
	
	#Split the results and return
	out=split(seq(pf),pf)
	out[[1]] = nmrs[,out[[1]]]
	out[[2]] = nmrs[,out[[2]]]
	names(out) <- c("x","y")
	return(out)
}



.norm_mrs <- function(M, pf, ...) { # median rank  scores algorithm  - a modification of quantile for multi-platform data
	idx <- tapply(seq(pf), pf, function(x) x)
	if (length(pf)<=0) return(M)
	#if (length(idx)==1) return(normalizeQuantiles(M))
	imax <- which.max(sapply(idx, length)) # for reference
	ref_med_srt <- sort(apply(M[, idx[[imax]]], 1, function(x) median(x, na.rm=TRUE) ))
	idx[imax] <- NULL
	lapply(unlist(idx), function(i) M[,i] <<- ref_med_srt[rank(M[,i])])
	invisible(M)
	}
	
	
.processplatforms = function(datalist, namesvec=NULL, skip.match=FALSE){
	#Convert data from various formats to the proper format for use 
	#with all the crossnorm normalization functions
	
	for(i in 1:length(datalist)){
		if(is.matrix(datalist[[i]])){
			datalist[[i]] <- as.data.frame(datalist[[i]])
		}
	}
	
	if (is.null(namesvec)){
		namesvec <- numeric(length(datalist))
		for (i in 1:length(datalist)){
			namesvec[i] <- 0
		}
	}
	
	#Put the row names in their places
	for (i in 1:length(namesvec)){
		if(namesvec[i] != 0){
			rownames(datalist[[i]]) = datalist[[i]][,namesvec[i]]
			datalist[[i]] = datalist[[i]][,-1*namesvec[i],drop=FALSE]
		}	
	}

	if(!skip.match){
		#Create the common genes list
		commongenes <- rownames(datalist[[1]])
		for (i in 2:length(datalist)){
			commongenes <- intersect(commongenes,rownames(datalist[[i]]))
		}
	
	
		#Put it all together
		for (i in 1:length(datalist)){
			datalist[[i]] <- datalist[[i]][commongenes,,drop=FALSE]
		}
	}
	return(datalist)
}

classifyprofile <-
function(data,pvalues=NULL,case=c("disease","drug"),type=c("fixed","dynamic","range"),lengthtest=100,ranges=seq(100,2000,by=100),adj=c("BH","qvalue"),dynamic.fdr=0.05,signif.fdr=0.05,customRefDB=NULL, noperm=1000,customClusters=NULL,clustermethod=c("single","average"),avgstat=c("mean","median"),cytoout=FALSE,customsif=NULL,customedge=NULL,cytofile=NULL,no.signif=10,stat=c("KS","WSR")){
	clustermethod<-match.arg(clustermethod)
	avgstat<-match.arg(avgstat)
	case<-match.arg(case)
	type<-match.arg(type)
	stat<-match.arg(stat)
	adj<-match.arg(adj)
	nodename=colnames(data)
	
	library(qvalue)
	if(!is.matrix(data)){
		data<-read.table(data,header=TRUE,row.names=1)
		data<-as.matrix(data)
	}
	if(!is.null(pvalues)&&!is.matrix(pvalues)){
		pvalues<-read.table(pvalues,header=TRUE,row.names=1)
		pvalues<-as.matrix(pvalues)
	}
#data<-as.matrix(data)
#pvalues<-as.matrix(pvalues)
	nodename=colnames(data)
	if(cytoout&&is.null(cytofile))stop('filename for cytoscape output needed')
	
	if(type=="dynamic"&&is.null(pvalues))stop('A numeric matrix of p-values or an lmobject is required to use p-values to select gene signatures')
	
	#read in customRefDB and customClusters if provided
	if(!is.null(customRefDB)&&!is.null(customClusters)){
		if(!is.matrix(customRefDB))customRefDB<-read.table(customRefDB,header=TRUE,row.names=1)
		if(!is.data.frame(customClusters))customClusters<-read.table(customClusters,header=TRUE)
		refnames<-colnames(customRefDB)
		refnames<-make.names(refnames)
		clustnames<-customClusters[,which(colnames(customClusters)%in%c("Drug","Disease"))]
		clustnames<-make.names(clustnames)
		intersection<-which(refnames%in%clustnames)
		if(length(refnames)!=length(intersection))stop('Profiles in custom rank profiles and clustom clusters do not match')
	}
		
	#calculate enrichment scores
	ESvals<-.calculateES(data,case=case,type=type,pvalues=pvalues,adj=adj,dynamic.fdr=dynamic.fdr,signif.fdr=signif.fdr,customRefDB=customRefDB,noperm=noperm,ranges=ranges,lengthtest=lengthtest,stat=stat)
	
			
	#assign significant enrichment scores to clusters		
	if(clustermethod=="single"){
			
		clusterassignments<-.classifysinglelinkage(ESvals$significance,customClusters=customClusters,case=case,no.signif=no.signif)
	}else{
		clusterassignments<-.classifyaveragelinkage(ESvals$scores,customClusters=customClusters,case=case,statistic=avgstat)
		
	}
	#check have at least one significant results
	nacheck<-unlist(clusterassignments)
	if(is.list(nacheck)){
		nacheck2<-unlist(nacheck)
		nas<-which(is.na(nacheck2))
		if(length(nas)==length(nacheck2)){stop('No significant matches found. Consider changing the FDR threshold')}

	}else{
		nas<-which(is.na(nacheck))
		if(length(nas)==length(nacheck)){stop('No significant matches found. Consider changing the FDR threshold')}
	}
	#generate cytoscape output
	if(cytoout){
		if(!is.null(customClusters)){
			if(is.null(customsif)|is.null(customedge)){
				stop('Custom SIF and Edge attribute file for cytoscape required since using custom clusters')
			}else{
				if(!is.data.frame(customsif)){customsif<-read.table(customsif,header=FALSE)}
				if(!is.data.frame(customedge)){customedge<-read.table(customedge,header=FALSE)}			
			}
		}
		.writecytoscape(case=case,clusterassignments=clusterassignments,filename=cytofile,customsif=customsif,customedge=customedge,nodename=nodename,customClusters=customClusters)
	}
	return(clusterassignments)
		
}

\documentclass[11pt]{article}
\usepackage{graphicx, verbatim}
\usepackage{hyperref}
\usepackage[utf8]{inputenc}
\setlength{\textwidth}{6.5in} 
\setlength{\textheight}{9in}
\setlength{\oddsidemargin}{0in} 
\setlength{\evensidemargin}{0in}
\setlength{\topmargin}{-1.5cm}
%\VignetteIndexEntry{DrugVsDisease}
\begin{document}

\begin{center}
{\bf \Large Drug versus Disease (DrugVsDisease) package} \\
\end{center}
\SweaveOpts{keep.source=TRUE}
\DefineVerbatimEnvironment{Sinput}{Verbatim}{xleftmargin=2em}
\DefineVerbatimEnvironment{SOutput}{Verbatim}{xleftmargin=2em}
\DefineVerbatimEnvironment{Scode}{Verbatim}{xleftmargin=2em}
\fvset{listparameters={\setlength{\topsep}{0pt}}}
\renewenvironment{Schunk}{\vspace{\topsep}}{\vspace{\topsep}}






\section{Introduction}
<<echo=FALSE>>=
options(width=60)
@
The Drug versus Disease (DrugVsDisease) package provides a pipeline for the comparison of drug and disease gene expression profiles where negatively correlated (enriched) profiles can be used to generate hypotheses of drug-repurposing and positively correlated (enriched) profiles may be used to infer side-effects of drugs. The package implements a number of processing options (for deriving ranked expression profiles) and different options for determining gene sets to use in Gene Set Enrichment Analysis. Currently the DrugVsDisease package can automatically process Affymetrix platforms hgu133a, hgu133a2 and hgu133plus2, which includes converting the probes to genes using the Biomart package. The DrugVsDisease package depends on the DvDdata package which contains a default set of reference drug and disease genomic expression profiles with corresponding clusters and Cytoscape compatible files for visualisation of the networks.


\section{A Simple Example}
As an example we use DrugVsDisease to download and automatically process an experiment from Array Express (which makes use of the ArrayExpress R package). This experiment (with accession E-GEOD-22528) compares patients with and without asthma. Using DrugVsDisease, and the default data provided by the DvDdata package, we compare the ranked list of differentially expressed genes to those of cell lines treated with 1309 different drug compounds. The output from the package gives the ranked lists of differential expression with associated p-values and the scores using Gene Set Enrichment Analysis to the reference data set. To do the analysis we first download the data from Array Express, convert the probes to genes using BiomaRt annotations, and calculate differential expression of genes using limma.
<<eval=FALSE>>=
library(DrugVsDisease)
profileAE<-generateprofiles(input="AE",accession="E-GEOD-22528")
@


We can see the data that has been generated, the names of profileAE are ranklist for the differential expression profiles and pvalues for the corresponding pvalues
<<eval=FALSE>>=
names(profileAE)
@


Within the ranklist or pvalues list, there is a matrix containing all fitted contrasts. DrugVsDisease expects that the profiles to be generated will contain either drug perturbations or a set of disease profiles. Using this information, DrugVsDisease searches the annotation files to find an allocate a main factor. This is disease.state for a disease profile or compound for a drug profile (based on the Array Express Factor values). The main factor is used as the explanatory factor in the regression model. In this example this is the only factor which can be fitted. In some cases, there will be additional factors, such as sex or time. Where these are available a second (additive) factor is added to the linear model automatically (in addition to the single factor model based on the main factor). The main factor in this example is given by "disease state" and the fitted contrasts are shown below.
<<eval=FALSE>>=
colnames(profileAE$ranklist)
@


As the above output shows, DrugVsDisease identifies the main factor but not which of the levels in the factor is the control. Consequently, all possible pairwise contrasts are fitted for the given levels of the factor. This means that there will be redundant contrasts which are not interesting to the user, in this example, asthma-normal is interesting whilst normal-asthma is not. The next step is therefore, to select those contrasts to be analysed further which is done using the selectrankedlists function.
<<eval=FALSE>>=
selprofiles<-selectrankedlists(profileAE,1)
@


Given the data to be analysed, we now use the classifyprofile function to calculate enrichment scores between the input profiles and the  data available from the DvDdata package (this can be changed to a users custom data). This data is based on the connectivity map drug screening. Here we use the default options to analyse the data. Note as this is an example, the signif.fdr value for the false discovery rate is set to 1.1, this is simply to restrict the situation where the process stops due to their being no significant matches, in practice the user should select a value greater than 0 and less than 1, 0.05 is a common choice.

<<results=tex,eval=FALSE>>=
default<-classifyprofile(data=selprofiles$ranklist, signif.fdr=1.1)
@
<<echo=FALSE,results=tex,eval=FALSE>>=
library(xtable)
default<-as.data.frame(default[[1]])
xtable(default[,2:4])
@


The table shows the output from classifyprofile. The distance between the input profile and all scores found to be statistically significant are given. They also include the cluster number of each of the drug profiles the input profile is connected to as well as the sign of the connection. A positive (1) for Running sum Peak Sign (RPS) denotes a positive correlation and (-1) a negative correlation.


\section{Importing Data}
DrugVsDisease has four options for processing Affymetrix microarray data, the options are selected using the "input" argument of generateProfiles. The options are "AE" for downloading raw CEL files from the Array Express data base, which uses the functionality of the ArrayExpress package, "localAE" allows the processing of Array Express CEL and SDRF files which have been downloaded and stored locally. From Gene Expression Omnibus, processed GDS files can be downloaded and analysed using the GEOquery package by selecting the "GEO" option. Finally the "local" option is used for any other Affymetrix files stored locally where the customfile option is used to supply the associated experimental design.


\textbf{Array Express Downloads}
In this first example we process data (where DrugVsDisease makes use of the ArrayExpress package), to analyse the experiment E-GEOD-22528 which looks at differences in patients with and without asthma.
<<label=AEx,eval=FALSE>>=
profileAE<-generateprofiles(input="AE",accession="E-GEOD-22528")
@

The output shows the contrasts which have been fitted by limma. The generateprofiles function automatically detects and fits all possible pairwise contrasts, giving contrasts asthma-normal and normal-asthma. To fit these contrasts DrugVsDisease uses the information in the expression set object created by the normalisation procedure from the affy package, which uses the information from the Array Express database to annotate the experimental design. The experimental design is contained in a standard SDRF file format and experimental factors should be prefixed with "Factor Value". DrugVsDisease uses this information to identify factors to include as explanatory variables in the regression. If a factor of interest has not been labelled as a "Factor Value" in the SDRF annotation it may be necessary to download the Array Express files and provide a manual annotation of the data using the option in DrugVsDisease for locally stored data.
\newline
\textbf{Locally stored Array Express files}
 Files downloaded from Array Express that have been stored locally can be processed using the input="localAE" option. Inputs required are the path to the CEL files and allows the sdrf file to be used for providing factor information. The path to the folder containing the CEL files is passed to R using the celfilepath parameter and the corresponding sdrf file path using parameter sdrfpath. Both these parameters therefore expect a string as input.
\newline
\textbf{Locally stored files}
To process a local data (not from Array Express or GEO), provide DrugVsDisease with a path to the folder containing CEL files and one to the file containing the experimental design.
The file containing the experimental design should have one column giving the names of the CEL files contained in the folder 'celfilepath' and should have column name "CEL" as well as either a "disease" column giving the disease state factor, or "compound" column for drug profiles. Any other factors can be provided in additional columns. The option input="local" is used to specify local files. Similar to the localAE option the path to the folder containing the CEL files is given by parameter celfilepath and an additional character string containing the experimental design via parameter customfile.
\newline
\textbf{GEO download}
For downloading GDS files the input parameter is set to "GEO" and the relevant database reference  on GEO is passed via the accession parameter. With GDS downloads sometimes the platform annotation is not available in the metadata, in this case it can be passed to DrugVsDisease using the annotation parameter as shown below (annotation="hgu133a"). Case is specified as "disease" (this is the default option). The case parameter tells the package which factor values to search for in the meta data e.g. disease.state for a disease profile or dose for a drug profile.
In some instances the metadata associated with the GDS file may not have the main factor as one of "disease state" or "disease.state" for a disease profile, or "dose" for a compound profile. For example the GDS profile 1479 has a main factor labelled as "specimen" in the GEO database. Using this information and the optional factorvalue parameter we can process the data by providing DrugVsDisease with the name of the factor in the experimental design.


<<label=GEO,results=hide,eval=FALSE>>=
gds1479<-generateprofiles("GEO",accession="GDS1479",
annotation="hgu133a",factorvalue="specimen",case="disease")
@


\section{Normalisation}
Where raw CEL files as opposed to processed GDS files are analysed the normalisation can be done in DrugVsDisease using one of rma (default) or mas5. For example, to use mas5 normalisation set normalisation="mas5".

\section{Calculating Differential Expression}


Ranked lists of differential expression (either log fold change, difference or t-statistic) and p-values are automatically calculated using limma. Differential expression is calculated between case and controls where \'case\' is either a disease or compound factor. For example to change to the t statistic instead of the default log fold change, add the option statistic="t" to the generateprofiles command.


The main 'case' factor is either identified from the phenotype (pData) of the expression set (eset) object produced following normalisation (see affy package), or it is specified by the user in the customfile option (see previous section). DrugVsDisease uses the metadata from GEO or Factor values of Array Express to automatically detect additional factors such as sex or time. Where the number of replicates allows, the data is stratified by the second factor. The differential expression for disease or compound factor is then calculated for a subset of the data split according to the different levels of a second factor e.g. male and female. 

\section{Selecting Ranked Lists}
As the generateprofiles function automatically generates profiles for every possible pairwise contrast there are likely to be some redundant proflies which the user does not wish to analyse further. The selectrankedlists function allows the user to select those profiles to be further analysed.
To select just the 3rd and 18th profile profile from gds1479 and the first from the Array Express profile E-GEOD-22528:
<<eval=FALSE>>=
sel1479<-selectrankedlists(gds1479,c(3,18))
@
<<eval=FALSE>>=
sel22528<-selectrankedlists(profileAE,1)
@



\section{Classifying Profiles}
The function {\it classifyProfile} has four main phases of, calculating Enrichment Scores, determining significant Enrichment Scores, assigning profiles to clusters and producing a network visualisation.

\subsection{Enrichment Scores:} 

The Enrichment Scores (ES) are calculated for up-regulated and down-regulated genes separately then averaged.The ES is the maximum value of the running sum statistic for input profiles compared to "inverted" reference profiles. For example, when using a disease profile of differentially expressed genes for case versus control, a significant score would indicate a potential therapeutic relationship. Conversely differentially expressed genes of control versus case (the inverse) would indicate a potential side-effect of that drug. 
Using the default options for classifyprofile the data generated from generateprofiles can be analysed as follows (where the cytoout=FALSE option indicates that no Cytoscape compatible format should be produced):

<<eval=FALSE>>=
default<-classifyprofile(data=sel22528$ranklist, signif.fdr=1.1)
@

A two sided test is used by DvD whereby a gene set of the same size is also generated from the reference data and compared to the input profile.
The gene sets for enrichment analysis, can be selected by one of three methods which is specified using the type parameter to classifyprofile The options are:
\begin{itemize}
\item{type="fixed": A fixed set size (default 100).}
\item{type="pvalues": P-values can be used to determine the set size by selecting probes for a given false discovery rate (default 5\%).}
\item{type="range": A fixed range of set sizes (default is between 100 and 2000 at intervals of 100).}
\end{itemize}

The classifyprofile function requires the ranklist of differential expression to be passed to the data parameter. The output from generateprofiles is a list with one element containing the ranked lists (ranklist) which is passed as the data option to classifyprofile. The second element contains the associated p-values which should be used as the pvalue input in classifyprofile when the type is set to dynamic.
\newline

Example classifying the profile to default drug clusters
<<eval=FALSE>>=
c1<-classifyprofile(data=sel22528$ranklist,type="fixed",lengthtest=100,
cytoout=FALSE,noperm=100)
@

Alternatively, classify the profile using a range of different gene set sizes (100 and 200).

<<eval=FALSE>>=
c2<-classifyprofile(data=sel22528$ranklist,type="range",range=c(100,200),
cytoout=FALSE,noperm=100)
@

Finally, using the dynamic option:
<<eval=FALSE>>=
c3<-classifyprofile(data=sel22528$ranklist,pvalues=sel22528$pvalues,
cytoout=FALSE,type="dynamic",dynamic.fdr=0.5,adj="BH")
@

\subsection{Significant Enrichment Scores and Multiple Hypothesis Correction:}
Significance of Enrichment Scores (ES) is determined by comparing the scores for a given input profile to a set of randomly generated reference profiles. These scores are used to define an empirical p-value. The number of random profiles generated can be set via the noperm option (default is 2000), see above examples with noperm=100.

 Multiple hypothesis correction is done when assessing the significance of the enrichment scores which have been calculated, the maximum number of significant results to output can be specified using the no.signif parameter (default 10). Two methods are available for multiple hypothesis correction (MHC) of ES q-value or Benjamini-Hochberg and the False discovery rate is set using the signif.fdr parameter. MHC is also used when the dynamic option is selected to correct genome-wide p-values of differential expression, this false discovery rate is set using dynamic.fdr. Example.
Classifying using 20\% F.D.R for significant results and 15\% F.D.R for the significance of differential expression (only required when type="dynamic"). Further to change to use the Benjamini Hochberg correction method instead of q-value approach of Tibshirani (this is applied to correction for differential expression where type="dynamic" and to correct for multiple hypothesis testing of significant enrichment scores) we have adj="BH".

<<eval=FALSE>>=
dynamicfdr<-classifyprofile(data=sel22528$ranklist,pvalues=sel22528$pvalues,
cytoout=FALSE,type="dynamic",dynamic.fdr=0.5,signif.fdr=0.15,adj="BH")
@


\subsection{Clustering:}
Two methods for assigning profiles to clusters are implemented in DrugVsDisease. One is single linkage, whereby an edge is drawn between the input and every significant match to the reference data. The second method is average linkage where the profile is assigned to the cluster with the largest average enrichment score over all nodes in the cluster, the 'average' score is set as either the arithemetic mean or the median via the avgstat parameter.

Example changing to average clustering (single is default) and using median as the statistic (mean is the default).
<<eval=FALSE>>=
clusteraverage<-classifyprofile(data=sel22528$ranklist,cytoout=FALSE,
clustermethod="average",avgstat="median")
@

\subsection{Custom Clusters}
As well as the default disease and drug clusters contained in the DvDdata package, DrugVsDisease offers the option to use custom reference data sets and clusters provided by the user. To use the custom cluster options the user needs to provide genome wide expression profiles for the reference data set, using the customRefDB parameter. The rank profiles should be in rank decreasing order such that the highest up-regulated has the lowest numerical rank. This can be either an R matrix containing the expression profiles or a string containing the path to a file containing the reference data. Where a path to a file is provided the file will be read using the read.table option in R and will expect rownames in the first column and the remaining columns should contain the rank profiles and the column names will be used as the names for each of the profiles in the reference data set. These names should match the node names for the customClusters parameter. As with the reference data, the custom Cluster option can take either an R matrix or a path specifying the filename for the custom Clusters data. The first column should be either "Drug" or "Disease" depending on whether the profiles are drug or disease profiles respectively. The second column should be headed "Cluster" and contain the cluster number of the corresponding node in the network.
If a cytoscape output is to be produced it is also necessary to provide a corresponding SIF and edge attribute file via parameters customsif and customedge. The DrugVsDisease package contains example data for the custom clustering option, which are derived from a subset of the reference drug data from the DvDdata package. This is shown in the example below, with the example data: customDB,customClust,customedge and customsif.

<<eval=FALSE>>=
data(customDB,package="DrugVsDisease")
data(customClust,package="DrugVsDisease")
data(customedge,package="DrugVsDisease")
data(customsif,package="DrugVsDisease")
customRefData<-classifyprofile(data=sel22528$ranklist, lengthtest=100,
customRefDB=customDB, customClusters=customClust, 
customedge=customedge, customsif=customsif, cytoout=FALSE,signif.fdr=1.1)
@


\subsection{Visualisation:} From R a Cytoscape compatible file is produced where the edge attribute is 1-ES, to give a distance metric of the input profile to the reference node. Nodes are the input profiles and the corresponding profiles (nodes) they are assigned to. Using the Cytoscape plug-in these results are automatically displayed after calculation. 
To produce Cytoscape compatible SIF and Edge Attribute files, the cytoout=TRUE option should be used as well as providing a filename via the cytofile parameter which is used to previx the name of the SIF and Edge attribute files.
<<eval=FALSE>>=
CytoOut<-classifyprofile(data=sel22528$ranklist,cytoout=TRUE,
cytofile="CytoscapeOutput",adj="BH")
@





\begin{thebibliography}{}
\bibitem[Hu {\it et~al}., 2009]{Hu09} Hu G, Agarwal P (2009) Human Disease-Drug Network Based on Genomic Expression Profiles, {\it PLoS ONE}, {\bf 4(8)}: e6536.

\bibitem[Shigemizu {\it et~al}., 2012]{Shi12} Shigemizu D, Hu Z, Hung J-H, Huang C-L, Wang Y, et al. (2012) Using Functional Signatures to Identify Repositioned Drugs for Breast, Myelogenous Leukemia and Prostate Cancer. {\it PLoS Comput Biol} {\bf 8(2)}: e1002347.

\bibitem[Sirota \textit{et~al}., 2011]{Sirota11}
Sirota M \textit{et~al}. (2011) Discovery and Preclinical Validation of Drug Indications Using Compendia of Public Gene Expression Data. \textit{Sci Trans Med}, \textbf{3:96ra77}.

\bibitem[Subramanian \textit{et~al}., 2005]{Sub05}
Subramanian A \textit{et~al}. (2005) Gene set enrichment analysis: A knowledge-based approach for interpreting genome-wide expression profiles. \textit{PNAS}, \textbf{102}(43), 15545-15550.

\bibitem[Lamb \textit{et~al}., 2006]{Lamb06}
Lamb J \textit{et~al}. (2006) The Connectivity Map: Using Gene-Expression Signatures to Connect Small Molecules, Genes, and Disease. \textit{Science}, \textbf{313}(5795), 1929-1935.

\bibitem[Gentleman \textit{et~al}., 2004]{Gentleman04}
Gentleman R \textit{et~al}. (2004) Bioconductor: open software development for computational biology and bioinformatics. \textit{Genome Biology}, \textbf{5}(10), R80.

\bibitem[Parkinson \textit{et~al}., 2010]{Parkinson10}
Parkinson et al. (2010) ArrayExpress update—an archive of microarray and high-throughput sequencing-based functional genomics experiments. \textit{Nucl. Acids Res.},doi: 10.1093/nar/gkq1040.

\bibitem[Edgar \textit{et~al}., 2002]{Edgar02}
Edgar R, Domrachev M, Lash AE. (2002) Gene Expression Omnibus: NCBI gene expression and hybridization array data repository. \textit{Nucl. Acids Res}, \textbf{30}(1):207-10 

\bibitem[R 2008]{RDev08}
R Development Core Team (2008). R: A language and environment for statistical computing. R Foundation for Statistical Computing, Vienna, Austria. ISBN 3-900051-07-0

\bibitem[Cline \textit{et~al}., 2007]{Cline07} 
Cline \textit{et al}. (2007) Integration of biological networks and gene expression data using Cytoscape. \textit{Nature Protocols}, \textbf{2}, 2366-2382.




\end{thebibliography}

\end{document}

\name{selprofile}
\alias{selprofile}
\docType{data}
\title{
List: Differential gene expression and p-values
}
\description{
Ranklist which has the rank of each gene according to differential expression. P-values is the second element in the list containing the associated p-value for gene differential expression.
}
\usage{data(selprofile)}
\format{
List with two elements, the first ranklist containing the ranked position of the gene according to its differential expression. The second item in the list is the associated pvalues.
}
\details{
Example ranked list of differential expression. Taken from Array express experiment E-GEOD-22528
}
\source{
\href{http://www.ebi.ac.uk/arrayexpress/experiments/E-GEOD-22528}{http://www.ebi.ac.uk/arrayexpress/experiments/E-GEOD-22528}
}

\examples{
data(selprofile)

## maybe str(selprofile) ; plot(selprofile) ...
}
\keyword{datasets}

\name{customedge}
\alias{customedge}
\docType{data}
\title{
Edge attributes for example custom network
}
\description{
Data frame containing the required format of an edge attribute file input into Cytoscape
}
\usage{data(customedge)}

\details{
Example subset of edge attributes taken from the full reference data set of drug compounds in the DvDdata package.
}
\source{
\href{http://www.broadinstitute.org/cmap/}{http://www.broadinstitute.org/cmap/}
}

\examples{
data(customedge)

}
\keyword{datasets}

\name{customClust}
\alias{customClust}
\docType{data}
\title{
Custom Clusters
}
\description{
Matrix containing a set of drugs and their corresponding clusters which can be used as input to the classifyprofile function.
}
\usage{data(customClust)}
\format{
Data frame with 47 rows and 2 columns. Columns are headed "Drug" and "Cluster". 
}
\details{

Each row refers to a compound in the customDB data set
\code{link{customDB}} with its corresponding cluster assignment in the
second column. These profiles are a subset of the Connectivity Map data
[1] (full set available in the DrugVsDiseasedata package
\pkg{DrugVsDiseasedata}, data object \code{drugRL}, for example use. Clusters
were generated using affinity propagation clustering [2]

}
\source{
\href{http://www.broadinstitute.org/cmap/}{http://www.broadinstitute.org/cmap/}
}
\references{
[1] Lamb J et~al. (2006) The Connectivity Map: Using Gene-Expression Signatures to Connect Small Molecules, Genes, and Disease. Science, 313(5795), 1929-1935.
[2] U. Bodenhofer, A. Kothmeier, and S. Hochreiter. APCluster: an R package for affinity propagation clustering. Bioinformatics, 27(17):2463-2464, 2011.
}
\examples{
data(customClust)

}
\keyword{datasets}

\name{classifyprofile}
\alias{classifyprofile}
\title{
Classify Profiles
}
\description{
For a set of ranked gene expression profiles, enrichment scores to a default or custom set of profiles. The ranked gene expression profiles can have been generated from generate profiles or provided by the user. The enrichment scores are assessed for significance using permutations to generate random profiles.
}
\usage{
classifyprofile(data, pvalues = NULL, case = c("disease", "drug"), type = c("fixed", "dynamic", "range"), lengthtest = 100, ranges = seq(100, 2000, by = 100), adj = c("BH","qvalue"), dynamic.fdr = 0.05, signif.fdr = 0.05, customRefDB = NULL, noperm = 1000, customClusters = NULL, clustermethod = c("single", "average"), avgstat = c("mean", "median"), cytoout = FALSE, customsif = NULL, customedge = NULL, cytofile = NULL, no.signif = 10,stat=c("KS","WSR"))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{
Matrix gene expression profiles. Rows are genes whose names match the genelist from DvDdata and columns are the different profiles. This can also be a path to a txt file containing the data.
}
  \item{pvalues}{
Optional numerical matrix of pvalues associated with the differential expression of the ranked lists in data argument. This can also be a path to a txt file containing the data.
}
  \item{case}{
Character string indicating whether or not the input profiles are disease (default) or drug profiles
}
  \item{type}{
Character string giving the method of gene set sizes, one of fixed (default), dynamic or range
}
  \item{lengthtest}{
Integer giving the number of genes to generate a set size for use with type=fixed, default 100.
}
  \item{ranges}{
A vector of integer values giving a range of gene set sizes, for use with type=range, default 100 to 2000 every 100.
}
  \item{adj}{
Character string to set the method for multiple hypothesis testing, one of qvalue or BH (default)
}
  \item{dynamic.fdr}{
Double giving the false discovery rate to determine the gene set sizes (default 5%) 
}
  \item{signif.fdr}{
Double giving the false discovery rate to determine significance of enrichment scores (default 5%)
}
  \item{customRefDB}{
Optional matrix of reference ranked profiles to compare the input profiles to. Alternatively a string giving the name of the path where the database is stored.
}
  \item{noperm}{
Integer for the number of permutation profiles (default 1000)
}
  \item{customClusters}{
Optional data frame of cluster assignments which relate to customRefDB
}
  \item{clustermethod}{
Character string to give the cluster method one of single (default) or average
}
  \item{avgstat}{
Character string for the statistic used with average cluster method. One of mean (default) or median.
}
  \item{cytoout}{
Logical if Cytoscape SIF and Edge Attribute files should be produced (default is FALSE)
}
  \item{customsif}{
Optional SIF input needed for use with custom clusters. Can be an R object or a character string containing a file path
}
  \item{customedge}{
Optional Edge attribute input needed for use with custom clusters. Can be an R object or a character string containing a file path
}
  \item{cytofile}{
Character string for the filename of the Cytoscape output
}
  \item{no.signif}{
Integer giving the maximum number of significant enrichment scores to return. Default is 10.
}
\item{stat}{One of KS (default) or WSR. KS is the Kolmogorov-Smirnov type statistic which equally weights all elements of the gene set. WSR uses both the sign and the position in the ranked list to calculate an enrichment score.}
}
\details{
The classify profile function contains a default set of drug (from the Connectivity Map [2]) and disease profiles (from various GEO profiles) with corresponding clusters which input profiles of disease and drug respectively are compared to. Enrichment scores [1] are calculated between the input profiles and the corresponding inverted reference profiles such that, the score measures the enrichment of up-regulated genes in the input profiles in the down-regulated genes in the reference set[3]. The gene set sizes to use in the Enrichment scores can be specified using one of three methods - fixed, range or dynamic. With the fixed method the user specifies a fixed number of genes to use with all input profiles. The range option takes a vector of integers - enrichment scores are calculated for each profile using a gene set size as given by the vector. The dynamic option uses the p-values to determine the gene set size according to the number of significantly differential expressed genes (following multiple hypothesis correction). Multiple hypothesis correction is done using one of two methods, qvalue or Benjamini-Hochberg.
Two enrichment scores are calculated for the up and down regulated scores. These contain the scores where the input profiles gene set is compared to the reference profile and where the reference profiles equivalent gene set (as determined by the type method) are compared to the input profile when using the KS option [4]. The WSR option implements the score of [5]. Various optional parameters exist for comparing an input profile to a users own reference set. For using custom reference data the user needs to provide the custom ranked lists of differential expression (customRefDB), the corresponding clusters (or network) between nodes in the reference data set (customClusters) and the SIF and Edge attribute files for Cytoscape option if cytoout=TRUE. Default clusters are provided by the DvDdata package, and include a drug and disease network. Input profiles to classifyprofile can be assigned to clusters using either single or average linkage. With single linkage an edge is drawn between the input profile and any significant scoring (up to a user defined maximum of no.signif) reference profiles. For average linkage either the mean or median (specified through avgstat) of the scores to each member in a cluster is calculated and the profile is assigned to the cluster with the highest average score.

To use your own preprocessed data, make sure the txt files for the data (and optional pvalues) have rownames with genes matching those in the reference data set. The files should have genes as row names in the first column and the header (col names) giving the names of the input profile(s). The input to classifyprofile is then a string of the path to the files.
}
\value{
Data Frame for each profile with elements:
\item{Node}{Names of the profiles with significant scores to the input profile(s)}
\item{ES Distance}{The distance between the input profile and corresponding reference profile. Defined as 1-ES}
\item{Cluster}{The cluster number of the node}
\item{RPS}{Running sum Peak Sign, taking values -1 to indicate an inverse relationship (potentially) therapeutic, or 1 to indicate a similar profile.}
}
\references{
[1]Subramanian A et~al. (2005) Gene set enrichment analysis: A knowledge-based approach for interpreting genome-wide expression profiles. PNAS, 102(43), 15545-15550.

[2]Lamb J et~al. (2006) The Connectivity Map: Using Gene-Expression Signatures to Connect Small Molecules, Genes, and Disease. Science, 313(5795), 1929-1935.

[3]Sirota M et~al. (2011) Discovery and Preclinical Validation of Drug Indications Using Compendia of Public Gene Expression Data. Sci Trans Med,3:96ra77.

[4]Iorio et al. (2010) Discovery of drug mode of action and drug repositioning from transcriptional responses. PNAS, 107(33), 14621-14626.

[5]Zhang S et al. (2008) A simple and robust method for connecting small- molecule drugs using gene-expression signatures. BMC Bioinformatics, 9:258.
}
\author{
C. Pacini
}




\seealso{
Function for generating profiles for input to classifyprofile: \code{\link{generateprofiles}}.
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
data(selprofile)
classification<-classifyprofile(data=selprofile$ranklist,signif.fdr=1,noperm=20)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{classify}
\keyword{profile}
\keyword{GSEA}

\name{profiles}
\alias{profiles}
\docType{data}
\title{
Gene Expression Profiles
}
\description{
List containing ranked lists of gene expression and associated p-values for a set of profiles.
}
\usage{data(profiles)}
\format{
	List containing rank of differential gene expression and pvalues in a list. Each item in the list contains a matrix. Matrix has number of rows equal number genes and columns for the different profiles.
}

\source{
\href{http://www.ebi.ac.uk/arrayexpress/experiments/E-GEOD-22528}{http://www.ebi.ac.uk/arrayexpress/experiments/E-GEOD-22528}
}

\examples{
data(profiles)
## maybe str(profiles) ; plot(profiles) ...
}
\keyword{datasets}

\name{generateprofiles}
\alias{generateprofiles}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Generate Profiles
}
\description{
Processing Affymetrix data to generate ranked lists of differential gene expression and associated p-values. 
}
\usage{
generateprofiles(input = c("AE", "GEO", "localAE", "local"), normalisation = c("rma", "mas5"), accession = NULL, customfile = NULL, celfilepath = NULL, sdrfpath = NULL, case = c("disease", "drug"), statistic = c("coef", "t", "diff"), annotation = NULL, factorvalue = NULL,annotationmap=NULL,type=c("average","medpolish","maxvar","max"),outputgenedata=FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{input}{
Character string denoting the source of the data. One of AE (default), GEO, localAE or local.
}
  \item{normalisation}{
Character string denoting the normalisation procedure as implemented in the affy package. One of mas5 (default) or rma.
}
  \item{accession}{
Optional character string giving the database reference for use with either the AE or GEO options.
}
  \item{customfile}{
Optional character string giving the path of a file containing the factor values associated with the CEL files specified in folder celfilepath
}
  \item{celfilepath}{
Optional character string giving the path of a folder containing CEL files to analyse.
}
  \item{sdrfpath}{
Optional character string giving path of an sdrf file corresponding to CEL files in celfilepath
}
  \item{case}{
Character string, one of disease (default) or drug denoting whether the input profiles are disease or drug profiles.
}
  \item{statistic}{
Character string, one of coef (default), t or diff. 
}
  \item{annotation}{
Optional character string giving the platform of the affymetrix files
}
  \item{factorvalue}{
Optional character string giving the name of the factor value in the GEO database.
}
	\item{annotationmap}{Optional matrix, or string to text file, containing an annotation map to convert from probes (first column) to HUGO gene symbols (second column). If passing a file path name the text file should have only two columns without rownames or headers.}
	\item{type}{The type of statistic to use to combine multiple probes to a single gene. Can be one of average (default) expression values, median polish, maxvar: the single probe to represent the set which has maximum variance or max to use the probe with maximal variance.}
\item{outputgenedata}{Boolean set to default FALSE. Outputs the gene data produced by generate profiles instead of the fitted coefficients from the linear models.}
}
\details{
Input types of AE and GEO use raw data download from Array Express using the ArrayExpress [1] package or processed GDS files from GEO using the GEOquery package [2]. CEL files and sdrf files downloaded from Array Express and stored locally can be processed using localAE option with the sdrf file path specified in sdrfpath and the path of the folder containing the CEL files contained in celfilepath. Users data stored locally can be processed using the local option with CEL file folders in celfilepath and factors associated with the CEL files in customfile. Where metadata may be missing from the GEO database, platform annotations can be specified using the annotation parameters and the name of main factor value (e.g. disease status, or compound treatment) using factorvalue option. 
Raw CEL files are normalised (rma or mast)[3] and data is converted from probes to genes using BioMart annotations [4]. Linear models are fitted using the database factor vales or user provided factors for locally stored data [5]. The differential expression is calculated for HUGO genes with the mapping performed automatically for Affymetrix platforms, HGU133A, HGU133Plus2 and HGU133A2 using BioMart. The differential expression statistic is one of coef (default), which corresponds to log (base 2) FC, diff (which is the difference between raw (non-logged) expression values, or t for the t-statistic based on log base 2 expression values.
}
\value{
List with two elements:
\item{Ranklist}{Matrix containing the ranks of gene expression. Rows containing the genes, columns the different profiles}
\item{Pvalues}{Matrix containing the associated p-values to the differential expression profiles in Ranklist}
}


\references{
[1]Kauffmann et al. (2009) Importing Array Express datasets into R/Bioconductor. Bioinformatics, 25(16):2092-4.

[2]Davis et al. (2007) GEOquery: a bridge between the Gene Expression Omnibus (GEO) and BioConductor. Bioinformatics, 14, 1846-1847.

[3]Irizarry et al. (2003) Summaries of Affymetrix GeneChip probe level data. Nucleic Acids Research, 31(4); e15.


[4]Durinck et al. (2009). Mapping identifiers for the integration of genomic datasets with the R/Bioconductor package biomaRt. Nature Protocols  4, 1184-1191.

[5]Smyth et al. (2004). Linear models and empirical Bayes method for assessing differential expression in microarray experiments. Statistical Applications in Genetics and Molecular Biology, Vol. 3, No. 1, Article 3. 
}
\author{
C. Pacini
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{classifyprofile}}
}
\examples{

#profileAE<-generateprofiles(input="AE",accession="E-GEOD-22528")

}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{selectrankedlists}
\alias{selectrankedlists}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Select Ranked Lists
}
\description{
Given a list with two elements, one containing ranklists for a set of regression models and the second containing the associated p-values. This function is used to extract a subset of the models.
}
\usage{
selectrankedlists(ranklist, colsinc)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
\item{ranklist}{
List with two elements (as output from generate profiles):
\emph{Ranklist}: Matrix containing the ranks of gene expression. Rows containing the genes, columns the different profiles.

\emph{Pvalues}: Matrix containing the associated p-values to the differential expression profiles in Ranklist.
}
 \item{colsinc}{
Vector of integers containing the column references of the profiles to select.
}
}
\details{
Format of list provided to selectrankedlists is the same as is output from generateprofiles \code{\link{generateprofiles}}. The output from selectrankedlists can be used as input to the classify profile function \code{\link{classifyprofile}}.
}
\value{
\item{Ranklist}{Matrix containing the ranks of gene expression. Rows containing the genes, columns the selected profiles}
\item{Pvalues}{Matrix containing the associated p-values to the differential expression profiles in Ranklist}

}

\author{
C. Pacini
}

\source{
\href{http://www.ebi.ac.uk/arrayexpress/experiments/E-GEOD-22528}{http://www.ebi.ac.uk/arrayexpress/experiments/E-GEOD-22528}
}
\seealso{
\code{\link{generateprofiles}}, \code{\link{classifyprofile}}.
}
\examples{
data(profiles)
selectprofile<-selectrankedlists(profiles,1)
classification<-classifyprofile(data=selectprofile$ranklist,noperm=10,signif.fdr=1)}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{DrugVsDisease-package}
\alias{DrugVsDisease-package}
\alias{DrugVsDisease}
\docType{package}
\title{
DrugVsDisease Package Overview
}
\description{
This package generates ranked lists of differential gene expression for either disease or drug profiles. Input data can be downloaded from Array Express [1] or GEO [2], or from local CEL files. Ranked lists of differential expression and associated p-values are calculated using Limma [3]. Enrichment scores [4] are calculated to a reference set of default drug or disease profiles, or a set of custom data supplied by the user. Significance scores are output in Cytoscape \href{http://www.cytoscape.org/}{http://www.cytoscape.org/} format.
}
\details{
\tabular{ll}{
Package: \tab DvD\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2012-06-15\cr
License: \tab GPL-2\cr
LazyLoad: \tab yes\cr
}
Profiles are calculated via generateprofiles and selected profiles are then classified using classifyprofile.
}
\author{
C. Pacini

Maintainer: J Saez-Rodriguez <saezrodriguez@ebi.ac.uk>
}
\references{
[1]Parkinson et al. (2010) ArrayExpress update an archive of microarray and high-throughput sequencing-based functional genomics experiments. Nucl. Acids Res.,doi: 10.1093/nar/gkq1040.

[2]Barrett T et al. (2011) NCBI GEO: archive for functional genomics data sets-10 years on. Nucl. Acids Res, 39, D1005-D1010.

[3]Smyth et al. (2004). Linear models and empirical Bayes method for assessing differential expression in microarray experiments. Statistical Applications in Genetics and Molecular Biology, Vol. 3, No. 1, Article 3. 

[4]Subramanian, A., Tamayo, P., Mootha, V. K., Mukherjee, S., Ebert, B. L.,
Gillette, M. A., Paulovich, A., Pomeroy, S. L., Golub, T. R., Lander,
E. S. & Mesirov, J. P. (2005) \emph{ Gene set enrichment analysis: A
knowledge-based approach for interpreting genome-wide expression profiles.}
Proc. Natl. Acad. Sci. USA 102, 15545-15550.


}

\keyword{ package }
\seealso{
\code{\link{generateprofiles}}, \code{\link{selectrankedlists}}, \code{\link{classifyprofile}}
}
\examples{
#profileAE<-generateprofiles(input="AE",accession="E-GEOD-22528")
#selprofiles<-selectrankedlists(profileAE,1)
#default<-classifyprofile(data=selprofiles$ranklist, signif.fdr=1.1)
}

\name{customsif}
\alias{customsif}
\docType{data}
\title{
SIF file for custom clusters
}
\description{
Data frame containing SIF format file of a network which could be input into the classifyprofile function.
}
\usage{data(customsif)}

\details{
Example subset of edge attributes taken from the full reference data set of drug compounds in the DvDdata package.
}
\source{
\href{http://www.broadinstitute.org/cmap/}{http://www.broadinstitute.org/cmap/}
}

\examples{
data(customsif)

}
\keyword{datasets}

\name{customDB}
\alias{customDB}
\docType{data}
\title{
Custom Gene Expression Profiles
}
\description{
Matrix containing a set of ranked gene expression profiles which can be used as custom input into classifyprofiles.
}
\usage{data(customDB)}

\details{
This is an example subset of the drugRL available in the DrugVsDiseasedata package
\pkg{DrugVsDiseasedata}, data object \code{drugRL}, based on data from the Connectivity
Map
}

\source{
\href{http://www.broadinstitute.org/cmap/}{http://www.broadinstitute.org/cmap/}
}

\examples{
data(customDB)
## maybe str(profiles) ; plot(profiles) ...
}
\keyword{datasets}

\name{combineProfiles}
\alias{combineProfiles}
\title{
Combine Profiles
}
\description{
Combine a set of hybridisations using the median rank method as proposed by Warnat
}
\usage{
combineProfiles(data)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{
A list of R objects, each object should contain a matrix of expression values to be merged with each other. The first object will be used as the reference data set.
}
}
\details{
The combine profiles function merges a set of expression values, normalising across different experiments to facilitate the meta-analysis of similar experiments i.e. cell lines treated with the same drug but which may be from different "batches" or platforms.}
\value{
Matrix of rank normalised expression data. Rows are genes, columns are hybridisations from the different experiments.}
\references{
R code from CONOR package. 
Need also reference to the method.
}
\author{
C. Pacini
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{classify}
\keyword{profile}
\keyword{GSEA}
